<?php

/*
 * Invision Power File Manager
 * Language Pack Manager
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 3rd March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("language settings file");
}

// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

// Build the list of text groups
$sections = array("Templates"            => "temp_description",
                  "Login Page"           => "login",
                  "Miscellaneous"        => "misc",
                  "Navigation Buttons"   => "area",
                  "Tool Buttons"         => "tools",
                  "File Listing"         => "main",
                  "Icon Legend"          => "legend",
                  "Javascript"           => "javascript",
                  "Status Messages"      => "operate",
                  "Change Password"      => "changepass",
                  "Space Usage"          => "space",
                  "MySQL Manager"        => "database",
                  "Source Viewer"        => "source",
                  "File Editor"          => "edit",
                  "File Compression"     => "compress",
                  "File Upload"          => "upload",
                  "CHMOD Dialog"         => "chmod",
                  "Move To/Copy To"      => "move",
                  "Directory Protection" => "lock",
                  "Multi-file Uploads"   => "uploads"
                  );

// Special information to show for different sections
$special = array("misc"         => "&nbsp;&nbsp;&nbsp;&nbsp;%s represents the time in seconds<br />&nbsp;&nbsp;&nbsp;&nbsp;%g represents the GZIP status",
                 "javascript"   => "&nbsp;&nbsp;&nbsp;&nbsp;%name is used for the file name",
                 "compress"     => "&nbsp;&nbsp;&nbsp;&nbsp;%program is used for the program name (Required)<br />&nbsp;&nbsp;&nbsp;&nbsp;%version is used for the program version (Required)<br />&nbsp;&nbsp;&nbsp;&nbsp;%name is used for the file name<br />&nbsp;&nbsp;&nbsp;&nbsp;%size is used for the file size",
                 "uploads"      => "&nbsp;&nbsp;&nbsp;&nbsp;%i is used for the file number",
                 "main"         => "&nbsp;&nbsp;&nbsp;&nbsp;%i is represents the directory"
                 );

if ($op == "del" || $op == "edit" || $op == "exp")
{
    // Need to check for only 1 (on delete) or 0 entries
    $first = 0;

    if ($op == "del")
    {
        $next       = "remove";
        $submit     = "Delete Language Pack";
        $pagetitle  = "Delete an Existing Language Pack";
    }
    else if ($op == "exp")
    {
        $next       = "get";
        $submit     = "Export Language Pack";
        $pagetitle  = "Export a Language Pack";
    }
    else
    {
        $next       = "change";
        $submit     = "Edit Language Pack";
        $pagetitle  = "Edit an Existing Language Pack";
    }

    if (count($lang_name) == 1 && $op == "del")
    {
        $data = msg("You cannot delete the last language pack");
    }
    else
    {
        $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
        $form .= "<input type=\"hidden\" name=\"op\" value=\"" . $next . "\">\r\n";
        $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please select a language pack from the list below</font></td>\r\n";
        $form .= "    </tr>\r\n";

        // List the languages
        foreach ($lang_name as $key => $var)
        {
            $form .= "    <tr>\r\n";
            if ($first == 0)
            {
                // Make sure the first file is checked
                $first = 1;
                $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"id\" value=\"" . $key . "\" checked=\"checked\"/></td>\r\n";
            }   
            else
            {
                $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"id\" value=\"" . $key . "\" /></td>\r\n";
            }
            $form .= "        <td><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $var . "</font></td>\r\n";
            $form .= "    </tr>\r\n";
        }

        if ($op == "del")
        {
            $form .= "    <tr>\r\n";
            $form .= "        <td colspan=\"2\" align=\"center\">&nbsp;</td>\r\n";
            $form .= "    </tr>\r\n";
            $form .= "    <tr>\r\n";
            $form .= "        <td width=\"1%\" valign=\"top\"><input type=\"checkbox\" value=\"1\" name=\"remove\" /></td>\r\n";
            $form .= "        <td valign=\"top\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Physically delete the language pack<br />(If you select this option the language pack will be deleted from the hard drive, not just removed from the system configuration)</font></td>\r\n";
            $form .= "    </tr>\r\n";
        }

        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"" . $submit . "\"></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "</table>\r\n";

        $data = msg($form, $pagetitle);
    }
}
else if ($op == "new")
{
    $pagetitle  = "Create an New Langauage Pack";

    // Load the default language
    if (!(include($script_dir . "/languages/" . $lang_file[$default_lang] . ".lng.php")))
    {
        include_error($lang_name[$default_lang] . " language pack");
    }

    $data = "<table border=\"0\" width=\"85%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	<tr>\r\n";
    $data .= "		<th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\">Create a New Language Pack</font></th>\r\n";
    $data .= "	</tr>\r\n";
    $data .= "	<tr>\r\n";
    $data .= "		<td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\">\r\n";
    $data .= "	    <form action=\"$PHP_SELF\" method=\"post\">\r\n";
    $data .= "		<input type=\"hidden\" name=\"op\" value=\"create\" />\r\n";
    $data .= "			<table border=\"0\" width=\"100%\" cellpadding=\"3\">\r\n";
    $data .= "				<tr>\r\n";
    $data .= "					<td align=\"center\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please edit the text below</font></td>\r\n";
    $data .= "				</tr>\r\n";
    $data .= "				<tr>\r\n";
    $data .= "					<td valign=\"top\" align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Language:</b></font></td>\r\n";
    $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[lang_name]\" value=\"" . $lang_name[$default_lang] . "\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">i.e &quot;English&quot;</font></td>\r\n";
    $data .= "	            </tr>\r\n";
    $data .= "				<tr>\r\n";
    $data .= "					<td valign=\"top\" align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>File Name:</b></font></td>\r\n";
    $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[lang_file]\" value=\"" . $lang_file[$default_lang] . "\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Without .lng.php extension, i.e &quot;en-gb&quot;</font></td>\r\n";
    $data .= "	            </tr>\r\n";
    $data .= "				<tr>\r\n";
    $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Character Set:</b></font></td>\r\n";
    $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[charset]\" value=\"" . $charset . "\" style=\"width: 90%\" /></td>\r\n";
    $data .= "	            </tr>\r\n";

    foreach ($sections as $key => $var)
    {
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>" . $key . "</i></font></td>\r\n";
        $data .= "				</tr>\r\n";

        if (isset($special[$var]) == TRUE)
        {
            $data .= "				<tr>\r\n";
            $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $special[$var] . "</font></td>\r\n";
            $data .= "				</tr>\r\n";
        }

        foreach (${$var} as $title => $value)
        {
            $value = str_replace("\"", "&quot;", $value);
            $value = str_replace("\\&quot;&quot; + name + &quot;\\&quot;", "%name", $value);

            $value = entity_convert($value, 0, 1);
               
            if ($var == "temp_description")
            {
                $temp_extension[0] = "default";

                $data .= "				<tr>\r\n";
                $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . $temp_extension[$title] . ":</b></font></td>\r\n";
                $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[$var][$title]\" value=\"" . $value . "\" style=\"width: 90%\" /></td>\r\n";
                $data .= "	            </tr>\r\n";
            }
            else
            {
                $data .= "				<tr>\r\n";
                $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . $title . ":</b></font></td>\r\n";
                $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[$var][$title]\" value=\"" . $value . "\" style=\"width: 90%\" /></td>\r\n";
                $data .= "	            </tr>\r\n";
            }
        }

        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
        $data .= "	            </tr>\r\n";
    }

    $data .= "				<tr> \r\n";
    $data .= "					<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Create Language Pack\" /></td>\r\n";
    $data .= "	            </tr>\r\n";
    $data .= "			</table>\r\n";
    $data .= "		    </form>\r\n";
    $data .= "		</td>\r\n";
    $data .= "	</tr>\r\n";
    $data .= "</table>\r\n";
}
else if ($op == "create")
{
    // Create the new language pack
    $new            = param("new", "POST");

    $charset        = $new["charset"];
    $new_lang_name  = $new["lang_name"];
    $new_lang_file  = $new["lang_file"];

    foreach ($new as $key => $var)
    {
        if ($key != "charset" && $key != "lang_name" && $key != "lang_file")
        {
            // Create the array
            ${$key} = $var;

            foreach ($var as $index => $value)
            {
                if (get_magic_quotes_gpc())
                {
                    ${$key}[$index] = stripslashes(${$key}[$index]);
                }

                if (${$key}[$index] == "")
                {
                    $error = 1;
                }

                if ($key == "javascript")
                {
                    ${$key}[$index] = str_replace("%name", "\\&quot;&quot; + name + &quot;\\&quot;", ${$key}[$index]);
                    ${$key}[$index] = str_replace("&quot;", "\"", ${$key}[$index]);
                }
                else if ($key == "compress")
                {
                    ${$key}[$index] = str_replace("&quot;", "\"", ${$key}[$index]);

                    if (ereg("%program", ${$key}["by"]) == FALSE || ereg("%version", ${$key}["by"]) == FALSE)
                    {
                        $error = 2;
                    }
                }
                else
                {
                    ${$key}[$index] = entity_convert(${$key}[$index], 0);
                }
            }
        } 
    }

    $pagetitle = "Create a New Language Pack";

    if ($charset == "" || $new_lang_name == "" || $new_lang_file == "" || $error == 1)
    {
        // Some fields are empty
        $data = msg("One or more of the fields was left empty<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");            
    }
    else if (in_array($new_lang_name, $lang_name) == TRUE)
    {
        // A language of that name already exists
        $data = msg("A language of that name already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and select another</a>");                
    }
    else if (in_array($new_lang_file, $lang_file) == TRUE)
    {
        // The language file already exists
        $data = msg("The language file already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and select another filename</a>");                
    }
    else if ($error == 2)
    {
        // Something was missing
        $data = msg("One of the required markers was missing from the <i>&quot;File Compression&quot;</i> section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");            
    }
    else if (eregi("[\\\/:*?\"<>|]", $new_lang_file) == TRUE || eregi("[\\\/:*?\"<>|]", $new_lang_name) == TRUE)
    {
        // Invalid Characters
        $data = msg("The language name or file name contains an invalid character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and correct this</a>", "User Error");
    }
    else if (rebuild_lang_pack($new_lang_file) == FALSE)
    {
        // There was an error
        $data = msg("There was an error create the " . $new_lang_name . " language file. Please ensure &quot;" . $script_dir . $slash . "languages" . $slash . "&quot; is writeable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>", "System Error");                    
    }
    else
    {
        $lang_name[] = $new_lang_name;
        $lang_file[] = $new_lang_file;

        // The file data
        $str = "<?php\r\n\r\n";
        $str .= "/*\r\n";
        $str .= " * Invision Power File Manager\r\n";
        $str .= " * Languages Configuration Script\r\n";
        $str .= " * Copyright (c) 2003 Invision Power Services\r\n";
        $str .= " * -------------------------------------\r\n";
        $str .= " * You may not remove the copyright or\r\n";
        $str .= " * redistribute the script in any form\r\n";
        $str .= " *\r\n";
        $str .= " * Authors: Stephen Ball <stephen@invisionfilemanager.com>\r\n";
        $str .= " *\r\n";
        $str .= " */\r\n\r\n";
        $str .= " // Language names\r\n";
        $str .= build_array($lang_name, "lang_name") . "\r\n";
        $str .= " // Language files\r\n";
        $str .= build_array($lang_file, "lang_file") . "\r\n";
        $str .= "?" . ">";

        if (($fp = fopen($script_dir . "/settings/languages.inc.php", "w")) == FALSE)
        {
            // There was an error editing the file
            $pagetitle = "System Error";
            $data = msg("There was an error editing the language configuration file, please ensure that the file &quot;" . $script_dir . "/settings/languages.inc.php&quot; is writeable<br /><br />Use the &quot;Import a Pack&quot; option to try and install your newly created language pack", $pagetitle);
        }
        else
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }

            $str = clean_crlf($str);

            // The file was opened and locked so write the data
            fwrite($fp, $str);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN);
            }
        
            fclose($fp);

            // The language file was created
            $data = msg("The " . $new_lang_name . " language file was successfully created.", "Language Pack Created");

        }
    }
}
else if ($op == "remove")
{
    $id     = param("id", "POST");
    $remove = param("remove", "POST");

    if ($id == $default_lang)
    {
        // Cannot delete the default language
        $pagetitle = "User Error";
        $data = msg("You can not delete the default language pack, use the &quot;Script Settings&quot; screen and change the default language before you fdelete it<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and select another</a>", $pagetitle);
    }
    else if (isset($lang_name[$id]) == FALSE)
    {
        // Invalid Language
        $pagetitle = "User Error";
        $data = msg("You did not select a valid language pack<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and select another</a>", $pagetitle);
    }
    else
    {
        $file = $lang_file[$id];
        $name = $lang_name[$id];

        // Remove the items from the array
        unset($lang_name[$id]);
        unset($lang_file[$id]);

        // The file data
        $str = "<?php\r\n\r\n";
        $str .= "/*\r\n";
        $str .= " * Invision Power File Manager\r\n";
        $str .= " * Languages Configuration Script\r\n";
        $str .= " * Copyright (c) 2003 Invision Power Services\r\n";
        $str .= " * -------------------------------------\r\n";
        $str .= " * You may not remove the copyright or\r\n";
        $str .= " * redistribute the script in any form\r\n";
        $str .= " *\r\n";
        $str .= " * Authors: Stephen Ball <stephen@invisionfilemanager.com>\r\n";
        $str .= " *\r\n";
        $str .= " */\r\n\r\n";
        $str .= " // Language names\r\n";
        $str .= build_array($lang_name, "lang_name") . "\r\n";
        $str .= " // Language files\r\n";
        $str .= build_array($lang_file, "lang_file") . "\r\n";
        $str .= "?" . ">";

        if (($fp = fopen($script_dir . "/settings/languages.inc.php", "w")) == FALSE)
        {
            // There was an error editing the file
            $pagetitle = "System Error";
            $data = msg("There was an error editing the language configuration file, please ensure that the file &quot;" . $script_dir . "/settings/languages.inc.php&quot; is writeable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and correct this</a>", $pagetitle);
        }
        else
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }

            $str = clean_crlf($str);

            // The file was opened and locked so write the data
            fwrite($fp, $str);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN);
            }
        
            fclose($fp);

            if ($remove == 1)
            {
                if (unlink($script_dir . "/languages/" . $name . ".lng.php") == FALSE)
                {
                    // Setting removed, but file not deleted
                    $pagetitle = "Language Pack Uninstalled";
                    $data = msg("The &quot;" . $name . "&quot; language pack has been removed, but could not deleted", $pagetitle);
                }
                else
                {
                    // File Deleted
                    $pagetitle = "Language Pack Deleted";
                    $data = msg("The &quot;" . $name . "&quot; language pack has been deleted", $pagetitle);
                }
            }
            else
            {
                $pagetitle = "Language Pack Uninstalled";
                $data = msg("The &quot;" . $name . "&quot; language pack has been removed, but not deleted", $pagetitle);
            }
        }
    }
}
else if ($op == "change")
{
    $pagetitle  = "Edit an Existing Langauage Pack";
    $id         = param("id", "POST");

    // Edit the language pack
    if (empty($lang_name[$id]) == TRUE)
    {
        // The user doesn't exist, what is the admin trying to do?
        $data = msg("Sorry but you did not select a valid language pack<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and select a valid language pack</a>");
    }
    else
    {
        // Load the default language to fill in any missing gaps
        if (!(include($script_dir . "/languages/" . $lang_file[$default_lang] . ".lng.php")))
        {
            include_error($lang_name[$default_lang] . " language pack");
        }

        // Now load the selected language
        if (!(include($script_dir . "/languages/" . $lang_file[$id] . ".lng.php")))
        {
            include_error($lang_name[$id] . " language pack");
        }

        $data = "<table border=\"0\" width=\"85%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
        $data .= "	<tr>\r\n";
        $data .= "		<th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\">Edit an Existing Language Pack</font></th>\r\n";
        $data .= "	</tr>\r\n";
        $data .= "	<tr>\r\n";
        $data .= "		<td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\">\r\n";
        $data .= "	    <form action=\"$PHP_SELF\" method=\"post\">\r\n";
        $data .= "		<input type=\"hidden\" name=\"op\" value=\"update\" />\r\n";
        $data .= "		<input type=\"hidden\" name=\"lang\" value=\"" . $id . "\" />\r\n";
        $data .= "			<table border=\"0\" width=\"100%\" cellpadding=\"3\">\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"center\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please edit the text below</font></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Character Set:</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[charset]\" value=\"" . $charset . "\" style=\"width: 90%\" /></td>\r\n";
        $data .= "	            </tr>\r\n";

        foreach ($sections as $key => $var)
        {
            $data .= "				<tr>\r\n";
            $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>" . $key . "</i></font></td>\r\n";
            $data .= "				</tr>\r\n";

            if (isset($special[$var]) == TRUE)
            {
                $data .= "				<tr>\r\n";
                $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $special[$var] . "</font></td>\r\n";
                $data .= "				</tr>\r\n";
            }

            foreach (${$var} as $title => $value)
            {
                $value = str_replace("\"", "&quot;", $value);
                $value = str_replace("\\&quot;&quot; + name + &quot;\\&quot;", "%name", $value);

                $value = entity_convert($value, 0, 1);
                
                if ($var == "temp_description")
                {
                    $temp_extension[0] = "default";

                    $data .= "				<tr>\r\n";
                    $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . $temp_extension[$title] . ":</b></font></td>\r\n";
                    $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[$var][$title]\" value=\"" . $value . "\" style=\"width: 90%\" /></td>\r\n";
                    $data .= "	            </tr>\r\n";
                }
                else
                {
                    $data .= "				<tr>\r\n";
                    $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>" . $title . ":</b></font></td>\r\n";
                    $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"new[$var][$title]\" value=\"" . $value . "\" style=\"width: 90%\" /></td>\r\n";
                    $data .= "	            </tr>\r\n";
                }
            }

            $data .= "		        <tr>\r\n";
            $data .= "					<td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
            $data .= "	            </tr>\r\n";
        }

        $data .= "				<tr> \r\n";
        $data .= "					<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Update Language Pack\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "			</table>\r\n";
        $data .= "		    </form>\r\n";
        $data .= "		</td>\r\n";
        $data .= "	</tr>\r\n";
        $data .= "</table>\r\n";
    }
}
else if ($op == "update")
{
    $new        = param("new", "POST");
    $lang       = param("lang", "POST");

    $charset    = $new["charset"];
    $error      = 0;

    foreach ($new as $key => $var)
    {
        // Create the array
        ${$key} = $var;

        if ($key != "charset")
        {
            foreach ($var as $index => $value)
            {
                if (get_magic_quotes_gpc())
                {
                    ${$key}[$index] = stripslashes(${$key}[$index]);
                }

                if (${$key}[$index] == "")
                {
                    $error = 1;
                }

                if ($key == "javascript")
                {
                    ${$key}[$index] = str_replace("%name", "\\&quot;&quot; + name + &quot;\\&quot;", ${$key}[$index]);
                    ${$key}[$index] = str_replace("&quot;", "\"", ${$key}[$index]);
                }
                else if ($key == "compress")
                {
                    ${$key}[$index] = str_replace("&quot;", "\"", ${$key}[$index]);

                    if (ereg("%program", ${$key}["by"]) == FALSE || ereg("%version", ${$key}["by"]) == FALSE)
                    {
                        $error = 2;
                    }
                }
                else
                {
                    ${$key}[$index] = entity_convert(${$key}[$index], 0);
                }
            }
        } 
    }

    $pagetitle = "Update Language Pack";

    if ($charset == "" || $error == 1)
    {
        // Some fields are empty
        $data = msg("One or more of the fields was left empty<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");            
    }
    else if ($error == 2)
    {
        // Something was missing
        $data = msg("One of the required markers was missing from the <i>&quot;File Compression&quot;</i> section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");            
    }
    else if (rebuild_lang_pack($lang_file[$lang]) == FALSE)
    {
        // There was an error
        $data = msg("There was an error updating the " . $lang_name[$lang] . " language file. Please ensure &quot;" . $script_dir . $slash . "languages" . $slash . $lang_file[$lang] . ".lng.php&quot; is writeable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>", "System Error");                    
    }
    else
    {
        // The language file was updated
        $data = msg("The " . $lang_name[$lang] . " language file was updated successfully.", "Language Pack Updated");                            
    }
}
else if ($op == "get")
{
    $lang   = param("id", "POST");
    $fname  = $script_dir . $slash . "languages" . $slash . $lang_file[$lang] . ".lng.php";

    if (isset($lang_file[$lang]) == TRUE && file_exists($fname) == TRUE)
    {
        // Download the file
        $name = basename($fname);

        // Set the headers
        header("Content-Disposition: attachment; filename=" . $name . "\r\n");
        header("Content-Type: application/octet-stream\r\n");
        header("Content-Length: " . filesize($fname) . "\r\n");
        header("Pragma: no-cache\r\n");
        header("Expires: 0\r\n");

        if (($fp = fopen($fname, "r")) == TRUE)
        {
            // Output the file
            echo fread($fp, filesize($fname));
            fclose($fp);
            exit(); 
        }
    }

    // If we get this far there was an error
    $pagetitle = "System Error";
    $data = msg("There was an unknown error whilst trying to download the language pack", $pagetitle);

}
else if ($op == "imp")
{
    if(($dp = opendir($script_dir . "/languages/")) == FALSE)
    {
        // Directory could not be opened
        $pagetitle = "System Error";
        $data = msg("The language directory could not be opened, please ensure that " . $script_dir . $slash . "languages" . $slash . " is readable", $pagetitle);
    }
    else
    {
        $files = array();

        while ($entry = readdir($dp))
        {
            $clean = str_replace(".lng.php", "", $entry);

            if (in_array($clean, $lang_file) == FALSE && is_file($script_dir . "/languages/" . $entry) && $entry != "." && $entry != "..")
            {
                // A language pack was found but not installed, add it to the list
                $files[$clean] = $clean;
            }
        }

        closedir($dp);

        if (count($files) == 0)
        {
            // No new language packs where located
            $pagetitle = "User Error";
            $data = msg("No new language packs where located, please ensure that you have uploaded them using the language pack uploader", $pagetitle);
        }
        else
        {
            $pagetitle = "Import a Language Pack";

            $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
            $form .= "<input type=\"hidden\" name=\"op\" value=\"imp_lng\">\r\n";
            $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
            $form .= "    <tr>\r\n";
            $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please select a file from the list below</font></td>\r\n";
            $form .= "    </tr>\r\n";
            $form .= "    <tr>\r\n";
            $form .= "        <td width=\"5%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>File Name</i></font></td>\r\n";
            $form .= "        <td width=\"90%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Import As.. (Language name, e.g. English)</i></font></td>\r\n";
            $form .= "        <td width=\"5%\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Import</i></font></td>\r\n";
            $form .= "    </tr>\r\n";

            natcasesort($files);

            // List the users
            foreach ($files as $key => $var)
            {
                $form .= "    <tr>\r\n";
                $form .= "        <td width=\"5%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $key . ".lng.php&nbsp;&nbsp;&nbsp;&nbsp;</font></td>\r\n";
                $form .= "        <td width=\"90%\"><input type=\"text\" name=\"new[lang_name][$key]\" value=\"" . $var . "\" style=\"width: 90%\" /><input type=\"hidden\" name=\"new[lang_file][$key]\" value=\"" . $key . "\" /></td>\r\n";
                $form .= "        <td width=\"5%\" align=\"center\"><input type=\"checkbox\" name=\"new[import][$key]\" value=\"1\" checked=\"checked\" /></td>\r\n";
                $form .= "    </tr>\r\n";
            }

            $form .= "    <tr>\r\n";
            $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Import Language Pack\"></td>\r\n";
            $form .= "    </tr>\r\n";
            $form .= "</table>\r\n";

            $data = msg($form, $pagetitle);
        }
    }
}
else if ($op == "imp_lng")
{
    $new    = param("new", "POST");
    $error  = 0;

    foreach ($new["lang_name"] as $key => $var)
    {
        if ($var != "" && $new["import"][$key] == 1)
        {
            if (eregi("[\\\/:*?<>|]", $var) == TRUE)
            {
                $error = 1;
            }
            else
            {
                $lang_name[] = str_replace("\"", "&quot;", $var);
                $lang_file[] = $new["lang_file"][$key];
            }
        }
    }


    // The file data
    $str = "<?php\r\n\r\n";
    $str .= "/*\r\n";
    $str .= " * Invision Power File Manager\r\n";
    $str .= " * Languages Configuration Script\r\n";
    $str .= " * Copyright (c) 2003 Invision Power Services\r\n";
    $str .= " * -------------------------------------\r\n";
    $str .= " * You may not remove the copyright or\r\n";
    $str .= " * redistribute the script in any form\r\n";
    $str .= " *\r\n";
    $str .= " * Authors: Stephen Ball <stephen@invisionfilemanager.com>\r\n";
    $str .= " *\r\n";
    $str .= " */\r\n\r\n";
    $str .= " // Language names\r\n";
    $str .= build_array($lang_name, "lang_name") . "\r\n";
    $str .= " // Language files\r\n";
    $str .= build_array($lang_file, "lang_file") . "\r\n";
    $str .= "?" . ">";

    if ($error == 1)
    {
        // There was an error in the language name
        $pagetitle = "User Error";
        $data = msg("One of the language name contains an invalid character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and correct this</a>", $pagetitle);
    }
    else if (($fp = fopen($script_dir . "/settings/languages.inc.php", "w")) == FALSE)
    {
        // There was an error editing the file
        $pagetitle = "System Error";
        $data = msg("There was an error editing the language configuration file, please ensure that the file &quot;" . $script_dir . "/settings/languages.inc.php&quot; is writeable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and correct this</a>", $pagetitle);
    }
    else
    {
        // The file was opened, now to lock it
        if ($flock == TRUE)
        {
            flock($fp, LOCK_EX);
        }
        
        $str = clean_crlf($str);

        // The file was opened and locked so write the data
        fwrite($fp, $str);
        if ($flock == TRUE)
        {
            flock($fp, LOCK_UN);
        }
        
        fclose($fp);

        $pagetitle = "Language Pack Imported";
        $data = msg("The language packs have been imported successfully", $pagetitle);
    }
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>