<?php

/*
 * Invision Power File Manager
 * Script Settings Manager
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 17th March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("language settings file");
}

// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

if ($op == "settings")
{
    // Display the script settings form
    $pagetitle      = "Edit Script Settings";

    natcasesort($lang_name);

    $list           = array("1" => "Hide files beginning with a dot", "0" => "Show files beginning with a dot");
    $hide_list      = dropdown($list, $hide_dot);
    $lang_list      = dropdown($lang_name, $default_lang);
    $debug_list     = dropdown(array("1" => "Enabled", "0" => "Disabled"), $debug);
    $flock_list     = dropdown(array("1" => "Use flock", "0" => "Don't use flock"), $flock);
    $ext_list       = dropdown(array("1" => "Can be edited", "0" => "Cannot be edited"), $no_ext);
    $edit_list      = dropdown(array("1" => "Lock files when they are being edited", "0" => "Don't lock files when they are being edited"), $edit_lock);
	$gzip_list		= dropdown(array("1" => "Use GZIP Compression", "0" => "Do not use GZIP compression"), $use_gzip);
	$http_list		= dropdown(array("1" => "Output HTTP Headers", "0" => "Do not output HTTP headers"), $http_headers);

    // NEW FEATURE
    $anon_list      = dropdown(array("1" => "Do not require the user to log in", "0" => "Require the user to log in"), $anon_access);

    $clean_format   = str_replace("{\A\\T}", "{AT}", $format);

    // If we are running on Windows, convert the "control character safe" path back to normal Windows paths
    if (eregi("win", PHP_OS))
    {
        $script_dir = str_replace("/r", "\\r", $script_dir);
        $script_dir = str_replace("/n", "\\n", $script_dir);
        $script_dir = str_replace("/t", "\\t", $script_dir);

        $script_dir = str_replace("/R", "\\R", $script_dir);
        $script_dir = str_replace("/N", "\\N", $script_dir);
        $script_dir = str_replace("/T", "\\T", $script_dir);
    }

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" name=\"settings\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"ch_settings\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Edit the Script Settings below</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Cookie Settings</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Admin:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $cookie_admin . "\" name=\"new[cookie_admin]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Username:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text \" value=\"" . $cookie_user . "\" name=\"new[cookie_user]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Password:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $cookie_pass . "\" name=\"new[cookie_pass]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Language:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $cookie_lang . "\" name=\"new[cookie_lang]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Temporary:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $cookie_temp . "\" name=\"new[cookie_temp]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Life Time:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $cookie_time . "\" name=\"new[cookie_time]\" style=\"width: 15%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">This is the number of seconds to store the cookies for<br />Leave blank if you want the cookie to expire when the browser is closed</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>File System Settings</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Script Path:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $script_dir . "\" name=\"new[script_dir]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No trailing slash needed</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Script URL:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $script_url . "\" name=\"new[script_url]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No trailing slash needed</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Hide File:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $hide . "\" name=\"new[hide]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Used to prevent access to a folder</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Note File:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $note . "\" name=\"new[note]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Used to add notes to a folder</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Hide dot (.) Files:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[hide_dot]\">" . $hide_list . "</select></a></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>File Locking:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[flock]\">" . $flock_list . "</select><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">This should only be disabled if you server doesn't support flock, i.e. Windows 95, 98 or ME</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Edit Lock:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[edit_lock]\">" . $edit_list . "</select><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">This option will create a &quot;.fileman&quot; file when I user opens the file in the file editor, this will prevent other users from then editing the file for 5 minutes or until the file is saved</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Edit Lock Timeout:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $timeout . "\" name=\"new[timeout]\" style=\"width: 15%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">If you enable the edit lock you must enter a timeout in seconds</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Default CHMOD:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $new_chmod . "\" name=\"new[new_chmod]\" style=\"width: 15%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">This is used when uploading files, making directories and creating new folders</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Other Settings</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"middle\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Default Language:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[default_lang]\">" . $lang_list . "</select></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Anonymous Access:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[anon_access]\">" . $anon_list . "</select><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">In order to use anonymous access you must create an account named &quot;guest&quot; (lowercase) with no password. This account will be used for anonymous access so set the permissions to reflect this</font></td>\r\n";
    $form .= "    </tr>\r\n";
	$form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"middle\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Debug Mode:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[debug]\">" . $debug_list . "</select></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>No Extension:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[no_ext]\">" . $ext_list . "</select><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">If this option is enabled you can edit files with no extension, but be warned this will corrupt the file if it is not an ASCII file</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>GZIP Compression:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[use_gzip]\">" . $gzip_list . "</select></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>HTTP Headers:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><select name=\"new[http_headers]\">" . $http_list . "</select></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"middle\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Maximum Uploads:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $upload_limit . "\" name=\"new[upload_limit]\" style=\"width: 15%\" /></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Date Format:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $clean_format . "\" name=\"new[format]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The syntax for this is located <a href=\"http://www.php.net/manual/en/function.date.php\" target=\"_blank\">in the PHP Manual</a><br />{AT} is replaced by the word &quot;at&quot; from the users language pack</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Control Panel Password</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"middle\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Password:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"new[adminpass]\" style=\"width: 90%\" /></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Retype Password:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"new[checkpass]\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Leave the above fields blank to keep your current password</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Update Settings\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "ch_settings")
{
    // Update the settings

    // Get the variables and trim them
    $new = param("new", "POST");
    array_walk($new, "trim");

    $pagetitle      = "Update Script Settings";

    // Strip slashes if needed
    if (get_magic_quotes_gpc() == TRUE)
    {
        $new["script_dir"] = stripslashes($new["script_dir"]);
    }
    $new["script_dir"] = ereg_replace("[" . $safe . "]$", "",  $new["script_dir"]); // Remove the trailing slash

    if ($new["cookie_admin"] == "" || $new["cookie_user"] == "" ||  $new["cookie_pass"] == "" || $new["cookie_lang"] == "" || $new["cookie_temp"] == "")
    {
        // The cookie details aren't complete
        $data = msg("A required field from the &quot;<i>Cookie Settings</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (preg_match("/^[\w]+$/", $new["cookie_admin"]) == FALSE || preg_match("/^[\w]+$/", $new["cookie_user"]) == FALSE || preg_match("/^[\w]+$/", $new["cookie_pass"]) == FALSE || preg_match("/^[\w]+$/", $new["cookie_lang"]) == FALSE || preg_match("/^[\w]+$/", $new["cookie_temp"]) == FALSE) 
    {
        // The cookie fields contain invalid names
        $data = msg("One of the cookie names contain invalid characters, you may only use A-Z, a-z, 0-9 and the underscore character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (preg_match("/^[0-9]/", $new["cookie_admin"]) == TRUE || preg_match("/^[0-9]/", $new["cookie_user"]) == TRUE || preg_match("/^[0-9]/", $new["cookie_pass"]) == TRUE || preg_match("/^[0-9]/", $new["cookie_lang"]) == TRUE || preg_match("/^[0-9]/", $new["cookie_temp"]) == TRUE)
    {
        // The cookie fields contain invalid names
        $data = msg("One of the cookie names contain invalid characters, names must start with either A-Z, a-z or the underscore character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["cookie_time"] != "" && preg_match("/^[0-9]+$/", $new["cookie_time"]) == FALSE)
    {
        // The cookie time is invalid
        $data = msg("You must enter a numeric value for the cookie life time<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["timeout"] != "" && preg_match("/^[0-9]+$/", $new["timeout"]) == FALSE)
    {
        // The lock timeout is invalid
        $data = msg("You must enter a numeric value for the edit lock timeout<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (preg_match("/^[0-7]+$/", $new["new_chmod"]) == FALSE)
    {
        // The CHMOD value is invalid
        $data = msg("You must enter a numeric value for the default CHMOD<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["script_dir"] == "" || $new["script_url"] == "" || $new["hide"] == "" || $new["note"] == "" || ($new["edit_lock"] == 1 && $new["timeout"] <= 0))
    {
        // The file settings aren't complete
        $data = msg("A required field from the &quot;<i>File System Settings</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["format"] == "" || eregi("^\{AT\}$", $new["format"]) == TRUE)
    {
        // The date format is missing
        $data = msg("You did not enter a date format<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["upload_limit"] < 1 || preg_match("/^[0-9]+$/", $new["upload_limit"]) == FALSE || $new["upload_limit"] == "")
    {
        // Max uploads invalid
        $data = msg("You did not enter a valid number of maximum uploads<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["adminpass"] != "" && strlen($new["adminpass"]) < 5)
    {
        // The new password is too short
        $data = msg("Your new password is too short<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($new["adminpass"] != "" && $new["adminpass"] != $new["checkpass"])
    {
        // The new passwords do not match
        $data = msg("Your new password does not match the check password<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else
    {
        // Set the new control panel password
        if ($new["adminpass"] != "")
        {
            $new["adminpass"] = md5($new["adminpass"]);
        }
        else
        {
            $new["adminpass"] = $adminpass;
        }
    
        if (update_config($new, 1) == FALSE)
        {
            // The settings could not be updated
            $data = msg("Sorry but the settings could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");
        }
        else
        {
            // The settings have been updated
            $data = msg("The settings have been updated", "ASCII File Types Updated");
        }    
    }
}
else if ($op == "types")
{
    // Display the file associations form
    $pagetitle = "File Type Associations";

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"updatetypes\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"4\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Below is a list of space seperated file extensions associated with each icon</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\">&nbsp;</td>\r\n";
    $form .= "        <td width=\"3%\" align=\"left\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Icon File</i></font></td>\r\n";
    $form .= "        <td width=\"95%\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>File Extensions</i></font></td>\r\n";
    $form .= "        <td width=\"1%\" align=\"center\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Delete</i></font></td>\r\n";
    $form .= "    </tr>\r\n";

    // Build the form for the file associations
    foreach ($icons as $key => $var)
    {
        // Sort the extension list
        $list = explode(" ", $var);
        natcasesort($list);
        $var = "";
        foreach ($list as $exts)
        {
            $var .= $exts . " ";
        }
        $var = trim($var);

        $form .= "    <tr>\r\n";
        $form .= "        <td width=\"1%\" valign=\"middle\"><img src=\"../images/icons/$key\" alt=\"$key\" title=\"$key\" border=\"0\" /></td>\r\n";
        $form .= "        <td width=\"3%\" align=\"left\" nowrap=\"nowrap\"><input type=\"text\" name=\"image[]\" size=\"15\" value=\"" . $key . "\"/> &nbsp;&nbsp;<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">=&gt;</font>&nbsp;&nbsp;</td>\r\n";
        $form .= "        <td width=\"95%\" align=\"left\"><input type=\"text\" name=\"types[]\" style=\"width: 90%\" value=\"" . $var . "\" /></td>\r\n";
        $form .= "        <td width=\"1%\" align=\"center\" valign=\"middle\"><input type=\"checkbox\" name=\"delete[]\" value=\"1\" /></td>\r\n";
        $form .= "    </tr>\r\n";
    }

    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\" colspan=\"4\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"4\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>New Associations</i></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\"><img src=\"../images/icons/unknown.gif\" name=\"icon1\" alt=\"\" border=\"0\" /></td>\r\n";
    $form .= "        <td width=\"3%\" align=\"left\" nowrap=\"nowrap\"><input onblur=\"javascript:updateicon('icon1', this)\" type=\"text\" name=\"image[]\" size=\"15\" /> &nbsp;&nbsp;<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">=&gt;</font>&nbsp;&nbsp;</td>\r\n";
    $form .= "        <td width=\"95%\" align=\"left\"><input type=\"text\" name=\"types[]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\">&nbsp;</td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\"><img src=\"../images/icons/unknown.gif\" name=\"icon2\" alt=\"\" border=\"0\" /></td>\r\n";
    $form .= "        <td width=\"3%\" align=\"left\" nowrap=\"nowrap\"><input onblur=\"javascript:updateicon('icon2', this)\" type=\"text\" name=\"image[]\" size=\"15\" /> &nbsp;&nbsp;<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">=&gt;</font>&nbsp;&nbsp;</td>\r\n";
    $form .= "        <td width=\"95%\" align=\"left\"><input type=\"text\" name=\"types[]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\">&nbsp;</td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\"><img src=\"../images/icons/unknown.gif\" name=\"icon3\" alt=\"\" border=\"0\" /></td>\r\n";
    $form .= "        <td width=\"3%\" align=\"left\" nowrap=\"nowrap\"><input onblur=\"javascript:updateicon('icon3', this)\" type=\"text\" name=\"image[]\" size=\"15\" /> &nbsp;&nbsp;<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">=&gt;</font>&nbsp;&nbsp;</td>\r\n";
    $form .= "        <td width=\"95%\" align=\"left\"><input type=\"text\" name=\"types[]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "        <td width=\"1%\" valign=\"middle\">&nbsp;</td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"4\" align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Note</b>: You can add up to 3 associations at a time<br /><b>Image Path</b>: " . $script_dir . $slash . "images" . $slash . "icons" . $slash . "</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"4\" align=\"center\"><input type=\"submit\" value=\"Update Associations\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "updatetypes")
{
    // Get the three arrays
    $image  = param("image", "POST");
    $types  = param("types", "POST");
    $delete = param("delete", "POST");

    // Build the "new" array
    $new["image"]   = $image;
    $new["types"]   = $types;
    $new["delete"]  = $delete;

    $pagetitle = "Update File Type Associations";

    if (update_config($new, 2) == FALSE)
    {
        // The settings could not be updated
        $data = msg("Sorry but the settings could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");
    }
    else
    {
        // The settings have been updated
        $data = msg("The settings have been updated<br /><br />You should add an entry {FILE_ICON} to the legend in the directory listing template, and an entry to the legend in at least your default language pack for each new icon you have added<br /><br />Currently this will need to be done by hand, open the language pack in a text editor, locate the section titled &quot;Text used for the legend&quot;, then add an item to the list, for example \$legend[&quot;new_icon&quot;] = &quot;New filetype&quot;;<br /><br />Once you have added the item to the default language pack, you can add it to the others via the language pack editor", "File Types Updated");
    }   
}
else if ($op == "ascii")
{
    // Display the ASCII file types
    $pagetitle = "Edit ASCII File Types";

    // Get the list of file types
    natcasesort($ascii);
    $list = "";
    foreach ($ascii as $var)
    {
        $list .= $var . " ";
    }
    $list = trim($list);

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"updateascii\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Below is a space seperated list of file types which can be edited via File Manager</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\"><textarea name=\"new\" style=\"width: 90%\" rows=\"15\" wrap=\"soft\">" . $list . "</textarea></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"center\"><input type=\"submit\" value=\"Update ASCII File Types\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "updateascii")
{
    // Update the ASCII file types
    $pagetitle = "Update ASCII File Types";

    // Get the variables
    $new = param("new", "POST");
    $new = trim($new);

    if ($new == "")
    {
        $data = msg("You did not enter any file extensions<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter at least 1 extension</a>");
    }
    else
    {
        if (update_config($new, 3) == FALSE)
        {
            // The settings could not be updated
            $data = msg("Sorry but the settings could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");
        }
        else
        {
            // The settings have been updated
            $data = msg("The settings have been updated", "ASCII File Types");
        }
    }
}
else if ($op == "names")
{
    // Display the file names form
    $pagetitle  = "Edit File Names";

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"ch_names\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">You should not change these value unless instructed to do so by a support technician from <a href=\"http://www.invisionpower.com\" target=\"_blank\">Invision Power Services</a></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Login Script:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["login"] . "\" name=\"new[login]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Directory Listing:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["main"] . "\" name=\"new[main]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>File Editor:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["edit"] . "\" name=\"new[edit]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Source Viewer:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["source"] . "\" name=\"new[source]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Server Space:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["space"] . "\" name=\"new[space]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Change Password:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["pass"] . "\" name=\"new[pass]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>SQL Manager:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["sql"] . "\" name=\"new[sql]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>CHMOD Dialog:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["chmod"] . "\" name=\"new[chmod]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Move/Copy Dialog:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["move"] . "\" name=\"new[move]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Directory Protection Dialog:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["lock"] . "\" name=\"new[lock]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Multi-File Uploads:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["upload"] . "\" name=\"new[upload]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>User List:</b></font></td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $scripts["userlist"] . "\" name=\"new[userlist]\" style=\"width: 90%\" /></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Update File Names\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "ch_names")
{
    // Get the form data
    $new = param("new", "POST");
    
    if ($new["login"] == "" || $new["main"] == "" || $new["edit"] == "" || $new["source"] == "" || $new["space"] == "" || $new["pass"] == "" || $new["sql"] == "" || $new["chmod"] == "" || $new["userlist"] == "" || $new["upload"] == "" || $new["lock"] == "" || $new["move"] == "")
    {
        // Some fields are empty
        $data = msg("One or more of the file names was left empty<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");    
    }
    else if (preg_match("/[\\/:*?\"<>|]/", $new["login"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["main"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["main"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["edit"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["source"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["space"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["pass"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["sql"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["chmod"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["userlist"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["move"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["lock"]) == TRUE || preg_match("/[\\/:*?\"<>|]/", $new["upload"]) == TRUE)
    {
        // The file names contain invalid characters
        $data = msg("One or more of the file names contains invalid characters<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (update_config($new, 4) == FALSE)
    {
        // The settings could not be updated
        $data = msg("Sorry but the settings could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");
    }
    else
    {
        // The settings have been updated
        $data = msg("The settings have been updated<br /><br />Remember to now rename the files, this was not done by the script. Also remember to CHMOD the files if the new name requires it, and add the shebang line (i.e. if you named the files *.cgi)", "File Names Updated");
    }
}
else if ($op == "vis")
{
    // Display the visual settings form
    $pagetitle  = "Edit Visual Settings";

    $free_rgb = $free_colour[0] . "," . $free_colour[1] . "," . $free_colour[2]; // Build the CSS RGB colours for "free" space
    $used_rgb = $used_colour[0] . "," . $used_colour[1] . "," . $used_colour[2]; // Build the CSS RGB colours for "used" space

    $free_hex = RGBtoHex($free_colour[0], $free_colour[1], $free_colour[2]);
    $used_hex = RGBtoHex($used_colour[0], $used_colour[1], $used_colour[2]);

    $form = "<form name=\"settings\" action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"ch_vis\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">This section allows you to easily change the colours used for the space usage chart, all other visual settings are changed by modifying the CSS file under &quot;System Templates&quot;</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\">&nbsp;</td>\r\n";
    $form .= "        <td align=\"left\" width=\"85%\" rowspan=\"3\">\r\n";
    $form .= "        <table width=\"100%\" cellpadding=\"2\" border=\"0\">\r\n";
    $form .= "            <tr>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Red</b></font></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Green</b></font></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Blue</b></font></td>\r\n";
    $form .= "                <td align=\"center\" width=\"40%\">&nbsp;</td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Hex Code</b></font></td>\r\n";
    $form .= "            </tr>\r\n";
    $form .= "            <tr>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('free_red', '1');\" onmousedown=\"javascript:start_timer('1', 'free_red', '1');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $free_colour[0] . "\" name=\"free_red\" onblur=\"javascript:update_rgb('1');\" size=\"3\" /><input type=\"button\" class=\"control\" onkeypress=\"javascript:decrease('free_red', '1');\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'free_red', '1');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('free_green', '1');\" onmousedown=\"javascript:start_timer('1', 'free_green', '1');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $free_colour[1] . "\" name=\"free_green\" onblur=\"javascript:update_rgb('1');\" size=\"3\" /><input type=\"button\" class=\"control\" onkeypress=\"javascript:decrease('free_green', '1');\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'free_green', '1');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('free_blue', '1');\" onmousedown=\"javascript:start_timer('1', 'free_blue', '1');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $free_colour[2] . "\" name=\"free_blue\" onblur=\"javascript:update_rgb('1');\" size=\"3\" /><input type=\"button\" class=\"control\" onkeypress=\"javascript:decrease('free_blue', '1');\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'free_blue', '1');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"40%\"><input type=\"text\" size=\"10\" name=\"free_rgb\" readonly=\"readonly\" style=\"border:1px solid #000000; width: 100%; border-color: black; background-color:rgb(" . $free_rgb . ")\"/></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"text\" value=\"" . $free_hex . "\" name=\"free_hex\" onblur=\"javascript:ConvertToRGB('1');\" size=\"8\" /></td>\r\n";
    $form .= "            </tr>\r\n";
    $form .= "            <tr>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('used_red', '2');\"onmousedown=\"javascript:start_timer('1', 'used_red', '2');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $used_colour[0] . "\" name=\"used_red\" onblur=\"javascript:update_rgb('2');\" size=\"3\" /><input type=\"button\" class=\"control\" onkeypress=\"javascript:decrease('used_red', '2');\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'used_red', '2');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('used_green', '2');\"onmousedown=\"javascript:start_timer('1', 'used_green', '2');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $used_colour[1] . "\" name=\"used_green\" onblur=\"javascript:update_rgb('2');\" size=\"3\" /><input type=\"button\" onkeypress=\"javascript:decrease('used_green', '2');\" class=\"control\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'used_green', '2');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"button\" class=\"control\" value=\"+\" onkeypress=\"javascript:increase('used_blue', '2');\"onmousedown=\"javascript:start_timer('1', 'used_blue', '2');\" onmouseup=\"javascript:stop_timer();\"><input type=\"text\" value=\"" . $used_colour[2] . "\" name=\"used_blue\" onblur=\"javascript:update_rgb('2');\" size=\"3\" /><input type=\"button\" onkeypress=\"javascript:decrease('used_blue', '2');\" class=\"control\" value=\"-\" onmousedown=\"javascript:start_timer('2', 'used_blue', '2');\" onmouseup=\"javascript:stop_timer();\"></td>\r\n";
    $form .= "                <td align=\"center\" width=\"40%\"><input type=\"text\" size=\"10\" name=\"used_rgb\" readonly=\"readonly\" style=\"border:1px solid #000000; width: 100%; border-color: black; background-color:rgb(" . $used_rgb . ")\"/></td>\r\n";
    $form .= "                <td align=\"center\" width=\"15%\"><input type=\"text\" value=\"" . $used_hex . "\" name=\"used_hex\" onblur=\"javascript:ConvertToRGB('2');\" size=\"8\" /></td>\r\n";
    $form .= "            </tr>\r\n";
    $form .= "        </table>\r\n";
    $form .= "        </td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Free Space:</b></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" width=\"15%\" valign=\"top\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Used Space:</b></font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Update Visual Settings\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "ch_vis")
{
    // Get the RGB colours
    $new["used"][0] = param("used_red", "POST");
    $new["used"][1] = param("used_green", "POST");
    $new["used"][2] = param("used_blue", "POST");

    $new["free"][0] = param("free_red", "POST");
    $new["free"][1] = param("free_green", "POST");
    $new["free"][2] = param("free_blue", "POST");    

    if (is_rgb($new["free"]) == false || is_rgb($new["used"]) == false)
    {
        // The RGB details aren't valid
        $data = msg("A required field from the &quot;<i>Pie Chart Colours</i>&quot; section is missing or invalid, remember you may only enter values between 0 - 255<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (update_config($new, 5) == FALSE)
    {
        // The settings could not be updated
        $data = msg("Sorry but the settings could not be updated. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . "settings.inc.php&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");
    }
    else
    {
        // The settings have been updated
        $data = msg("The settings have been updated", "Visual Settings Updated");
    }
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>