<?php

/*
 * Invision Power File Manager
 * System Templates Manager
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 27th March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// Include the language data
if (!(include($script_dir . "/admin/templates.inc.php")))
{
    include_error("system template settings file");
}


// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

if ($op == "list")
{
    // Display the new template form
    $pagetitle = "Select a template";

    $page = "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $total = count($templates);

    foreach ($templates as $key => $var)
    {
        if ($key < $total )
        {
            $page .= "    <tr>\r\n";
            $page .= "        <td align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"$PHP_SELF?op=edit&tmp=" . $key . "\">" . $var . " Template</a></font></td>\r\n";
            $page .= "    </tr>\r\n";
        }
        else
        {
            $page .= "    <tr>\r\n";
            $page .= "        <td align=\"left\">&nbsp;</td>\r\n";
            $page .= "    </tr>\r\n";
            $page .= "    <tr>\r\n";
            $page .= "        <td align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"$PHP_SELF?op=edit&tmp=" . $key . "\">Cascading Style Sheet</a></font></td>\r\n";
            $page .= "    </tr>\r\n";
        }
    }



    $page .= "</table>\r\n";

    $data = msg($page, $pagetitle); 
}
else if ($op == "info")
{
    $pagetitle = "Template Placemarkers";
    $id = param("tmp", "GET");

    $page .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";

    $num = count($required[$id]);
    $i = 0;

    foreach ($vars[$id] as $key => $var)
    {
        // If the place marker is required mark it in italic
        if (in_array($key, $required[$id]) == TRUE)
        {
            $key = "<i>" . $key . "</i>";
            $var = "<i>" . $var . "</i>";
        }

        // Once we have printed the last required place marker break the list up
        if ($i == $num)
        {
            $page .= "    <tr>\r\n";
            $page .= "        <td align=\"center\" colspan=\"2\"><hr width=\"85%\"></td>\r\n";
            $page .= "    </tr>\r\n";
        }

        $page .= "    <tr>\r\n";
        $page .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>&#123;" . $key . "&#125;</b></font></td>\r\n";
        $page .= "        <td align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $var . "</font></td>\r\n";
        $page .= "    </tr>\r\n";

        $i++;
    }

    $page .= "</table>\r\n";

    $data = msg($page, $pagetitle);

}
else if ($op == "edit")
{
    $id = param("tmp", "GET");
    $total = count($templates);

    if ($id < 1 || $id > $total)
    {
        // The user didn't select a valid template so show the list again
        redirect("admin/system.php?op=list");
    }

    $path = $script_dir . $files[$id];

    if (($fp = fopen($path, "r")) == FALSE)
    {
        
        if (eregi("win", PHP_OS) == TRUE)
        {
            // If we're on Windows make the paths display correctly
            $path = str_replace("/", "\\", $path);
        }

        $form      = "There was an error opening the template, ensure that &quot;" . $path . "&quot; is readable";
        $pagetitle = "System Error";
    }
    else
    {
        $pagetitle = $id == $total ? "Edit the Cascading Style Sheet" : "Edit the " . $templates[$id] . " template";

        // The file was opened, now to lock it
        if ($flock == TRUE)
        {
            flock($fp, LOCK_EX);
        }
        
        // The file was opened and locked so read the data
        $fdata = fread($fp, filesize($path));
        if ($flock == TRUE)
        {
            flock($fp, LOCK_UN);
        }
        fclose($fp);

        // Convert entities so they display correctly
        $fdata = str_replace("</textarea>", "&lt/textarea&gt", $fdata); // A small fix so that the form isn't screwed up
        $fdata = preg_replace("/&(.+?);/", "&amp;\\1;", $fdata);

        $require = "";
        foreach ($required[$id] as $var)
        {
            $require .= "&#123;" . $var . "&#125;, ";
        }
        $require = preg_replace("/, $/", "", $require);

        $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" name=\"template\">\r\n";
        $form .= "<input type=\"hidden\" name=\"op\" value=\"update\">\r\n";
        $form .= "<input type=\"hidden\" name=\"tmp\" value=\"" . $id . "\">\r\n";
        $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";

        if ($id != $total)
        {
            $form .= "    <tr>\r\n";
            $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Required:</b></font></td>\r\n";
            $form .= "        <td align=\"left\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" .  $require . "</font></td>\r\n";
            $form .= "    </tr>\r\n";
            $form .= "    <tr>\r\n";
            $form .= "        <td align=\"left\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><a href=\"javascript:open_window('$PHP_SELF?op=info&tmp=" . $id . "');\" onmouseover=\"javascript:window.status='View Template Placemarkers'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">View Template Placemarkers</a></font></td>\r\n";
            $form .= "    </tr>\r\n";
        }

        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"center\" colspan=\"2\"><textarea wrap=\"soft\" name=\"fdata\" cols=\"100\" style=\"width: 90%\" rows=\"25\">{FDATA}</textarea></td>\r\n";
        $form .= "    </tr>\r\n";

        if ($info[$id] != "")
        {
            $form .= "    <tr>\r\n";
            $form .= "        <td align=\"left\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" .  $info[$id] . "</font></td>\r\n";
            $form .= "    </tr>\r\n";
        }

        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Save Changes\">  <input type=\"button\" value=\"Disable Wrapping\" name=\"wrapping\" onclick=\"javascript:wrap();\"></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "</table>\r\n";
        $form .= "</form>\r\n";

    }      

    $data = msg($form, $pagetitle);
}
else if ($op == "update")
{
    $id = param("tmp", "POST");

    $total = count($templates);

    if ($id < 1 || $id > $total)
    {
        // The user didn't select a valid template so show the list again
        redirect("admin/system.php?op=list");
    }

    $fdata = param("fdata", "POST");
    $fdata = trim($fdata);

    // Convert entities bak
    $fdata = str_replace("&lt/textarea&gt", "</textarea>", $fdata); // A small fix so that the form isn't screwed up
    $fdata = preg_replace("/&amp;(.+?);/", "&\\1;", $fdata);

    if (empty($fdata) == TRUE)
    {
        // We use a real link here rather than Javascript so that the page is actually reloaded rather than using the cached version, i.e. to repopulate the template
        $page       = "Sorry but you must you cannot have a blank template<br /><a href=\"$PHP_SELF?op=edit&tmp=" . $id . "\">&laquo; Please go back and correct this</a>";
        $pagetitle  = "User Error";
    }
    else
    {
        $error = FALSE;

        foreach ($required[$id] as $var)
        {
            if (ereg($var, $fdata) == FALSE)
            {
                $page       = "Sorry but the required place marker &#123;" .  $var . "&#125; is missing<br /><a href=\"javascript:history.go(-1);\">&laquo; Please go back and correct this</a>";
                $pagetitle  = "User Error";
                $error      = TRUE;
                break;
            }
        }
        if ($error == FALSE)
        {
            $path = $script_dir . $files[$id];

            if (($fp = fopen($path, "w")) == FALSE)
            {
  
                if (eregi("win", PHP_OS) == TRUE)
                {
                    // If we're on Windows make the paths display correctly
                    $path = str_replace("/", "\\", $path);
                }

                $page      = "There was an error opening the template, ensure that &quot;" . $path . "&quot; is writeable";
                $pagetitle = "System Error";
            }
            else
            {
                $page      = "The changes have been successfully saved";
                $pagetitle = "Save the " . $templates[$id] . " template";

                // The file was opened, now to lock it
                if ($flock == TRUE)
                {
                    flock($fp, LOCK_EX);
                }

                $fdata = clean_crlf($fdata);
        
                // The file was opened and locked so write the data
                fwrite($fp, $fdata);
                if ($flock == TRUE)
                {
                   flock($fp, LOCK_UN);
                }
                fclose($fp);
            }
        }
    }

    $data = msg($page, $pagetitle);
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset, "FDATA" => $fdata);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>