<?php

/*
 * Invision Power File Manager
 * Template List
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager>
 *
 * Last Modified: 26th March 2003 
 *
 */

// This script is for internal use in the Control Panel only so you should NOT edit it

// The first 3 arrays contain "display data", i.e. instructions for the user

// This array is a list of the template names
$templates = array(
        "1"     => "Global",
        "2"     => "File Listing",
        "3"     => "Login Screen",
        "4"     => "MySQL Manager",
        "5"     => "MySQL Error",
        "6"     => "MySQL Query Result",
        "7"     => "Space Usage",
        "8"     => "Change Password",
        "9"     => "File Editor",
        "10"    => "Source Viewer",
        "11"    => "CHMOD Dialog",
        "12"    => "Move To/Copy To Dialog",
        "13"    => "Directory Protection Dialog",
        "14"    => "Multi-file Uploads",
        "15"    => "Cascading Style Sheet"
        );

// This array is a list of the "place markers" which can be used in each template
$vars = array(
        "1"  => array(
             "TITLE"         => "Indicates where the page title should appear (Required)",
             "JAVASCRIPT"    => "Indicates where the javascript should be placed (Required)",
             "CONTENT"       => "Indicates the location of the main output (Required)",
             "CHARSET"       => "The character set from the users language pack (Required)",
             "COPYRIGHT"     => "Indicated where the copyright should be placed (Required)",
             "GZIP"          => "The marker to display the gzip compression status",
             "STATS"         => "Where to display the script page generation times"
             ),
        "2"  => array(
             "MSG"           => "The place to show any error messages (Required)",
             "NAV"           => "The navigation bar (Required)",
             "AREAS"         => "The area buttons such as Log out (Required)",
             "UP"            => "The &quot;Up one directory&quot; link",
             "THIS"          => "The current file name",
             "NEXT_DIR"      => "The next directory to display when submitting forms",
             "FILES_LBL"     => "The column title for files",
             "ACTIONS_LBL"   => "The column title for action buttons such as delete",
             "ZIP_LBL"       => "The column title for file compression",
             "ICON"          => "The file icon",
             "NAME"          => "The file name",
             "CHMOD"         => "The CHMOD label",
             "CHMOD_VAL"     => "The actual CHMOD value",
             "FILE_SIZE"     => "The file size label",
             "FSIZE"         => "The actual file size",
             "FOLDOWN"       => "The folder owner label",
             "FILEOWN"       => "The file owner label",
             "OWNER"         => "The actual owner name",
             "FOLDGROUP"     => "The folder group label",
             "FILEGROUP"     => "The file group label",
             "GROUP"         => "The actual group name",
             "MODIFIED"      => "The date last modified label",
             "MDATE"         => "The actual date (the format can be changed on the settings screen)",
             "ACTIONS"       => "The location of the action buttons, such as delete",
             "ZIPFILE"       => "The location of the add to zip check box",
             "TOTAL"         => "The total size label",
             "TOTAL_SIZE"    => "The actual total size",
             "FILE_OPS"      => "The file options label",
             "NEW_FOLD_NAME" => "The name of new folders",
             "NEW_FOLD"      => "The &quot;Create new folder&quot; button",
             "TEMPLATE_DROPDOWN" => "A dropdown list of the different templates",
             "NEW_FILE"      => "The &quot;Create new file&quot; button",
             "LOCAL"         => "The local filename label",
             "UPLOAD"        => "The upload button text",
             "UPNAME"        => "The remote filename label",
             "FILE_COMP"     => "The file compression header",
             "ZIP"           => "The zip filename label",
             "COMPRESS"      => "The compress button text",
             "OPTIONS"       => "The compression options label",
             "STORE"         => "The &quot;Save to disk&quot; option",
             "SEND"          => "The &quot;Download&quot; option",
             "BOTH"          => "The &quot;Save to disk &amp; download &quot; option",
             "DIR_INFO"      => "The header text for the &quot;directory info&quot; pane",
             "CUR_DIR"       => "The current directory label",
             "THIS_DIR"      => "The current directory",
             "IS_ROOT_LBL"   => "The &quot;Is Root?&quot; label",
             "IS_ROOT"       => "The &quot;Is Root?&quot; value",
             "IS_READ_LBL"   => "The &quot;Is Readable?&quot; label",
             "IS_READ"       => "The &quot;Is Readable?&quot; value",
             "IS_WRITE_LBL"  => "The &quot;Is Writable?&quot; label",
             "IS_WRITE"      => "The &quot;Is Writable?&quot; value",
             "FOLDOWN"       => "The folder owner label",
             "FOLD_OWN"      => "The folder owner value",
             "FOLDGROUP"     => "The folder group label",
             "FOLD_GROUP"    => "The folder group value",
             "FILES_IN_DIR"  => "The label to show the number of files in the current directory",
             "FILE_COUNT"    => "The actual number of files",
             "FOLDERS_IN_DIR" => "The number of folder in the current directory",
             "FOLDER_COUNT"  => "The actual number of folder",
             "LEGEND"        => "The icon legend header",
             "FILE_A_DIR"    => "The files and directory label",
             "DEL_ICON"      => "The delete label",
             "RENAME_ICON"   => "The rename label",
             "CHMOD_ICON"    => "The CHMOD label",
             "MOVE_ICON"     => "The move-to label",
             "COPY_ICON"     => "The copy-to label",
             "EDIT_ICON"     => "The edit label",
             "HTPASS_ICON"   => "The password protect label",
             "MULTI_UPLOAD"  => "The page to upload multible files",
             "MULTIPLE"      => "The multi file upload button"
             ),
        "3"  => array(
             "THIS"          => "The form action (Required)",
             "INSTRUCTIONS"  => "Instructions to the user (Required)",
             "SUBMIT"        => "The submit button text (Required)",
             "USERNAME"      => "The username label",
             "PASSWORD"      => "The password label",
             "LANGUAGE"      => "The language label",
             "LANGUAGES"     => "The languages list",
             "CAPTION"       => "The &quot;Login&quot; header"
             ),
        "4"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "THIS"          => "The form action (Required)",
             "SUBMIT"        => "The text for the submit button (Required)",
             "CAPTION"       => "The page heading",
             "VERSION_LBL"   => "The version label",
             "VERSION"       => "The actual MySQL version",
             "DATABASE_LBL"  => "The database label",
             "DATABASE"      => "The actual drop down list of databases",
             "SQL_LBL"       => "The SQL label"
             ),
        "5"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "ERR_MSG"       => "The actual error message (Required)",
             "CAPTION"       => "The page heading",
             "ERR_NUM_LBL"   => "The label for the error number",
             "ERR_NUM"       => "The actual error number",
             "ERR_MSG_LBL"   => "The label for the error message"
             ),
        "6"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "THIS"          => "The form action (Required)",
             "DB"            => "The database ID (Required)",   
             "RESULT"        => "The query result (Required)",             
             "CAPTION"       => "The page heading",
             "VERSION_LBL"   => "The version label",
             "VERSION"       => "The actual MySQL version",
             "DATABASE_LBL"  => "The database label",
             "DATABASE"      => "The actual database used",
             "SQL_LBL"       => "The SQL label",
             "SQL"           => "The actual SQL query issued",
             "RESULT_LBL"    => "The query result label",
             "NEW"           => "The text for the &quot;New Query&quot; button"
             ),
        "7"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",        
             "IMG"           => "The location of the pie chart image (Required)",
             "TITLE"         => "The page heading",
             "STATS"         => "The statistics label",
             "USED_LBL"      => "The used space label",
             "USED"          => "The actual amount of used space",
             "FREE_LBL"      => "The free space label",
             "FREE"          => "The actual amount of free space",
             "TOTAL_LBL"     => "The total space label",
             "TOTAL"         => "The actual amount of space"
             ),
        "8"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "THIS"          => "The form action (Required)",
             "SUBMIT"        => "The text used on the submit button (Required)",
             "TITLE"         => "The page heading",
             "NEWPASS"       => "The new password label",
             "NEWPASS2"      => "The confirm new password label"
             ),
        "9"  => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "THIS"          => "The form action (Required)",
             "NEXT_DIR"      => "The next directory (Required)",
             "IS_NEW"        => "Switch for if the file is new or not (Required)",
             "FILENAME"      => "The file name (Required)",
             "FDATA"         => "The file content (Required)",
             "SUBMIT"        => "The text used on the submit button (Required)",
             "WRAP"          => "The text used on the wrapping button (Required)",
             "TITLE"         => "The page heading",
             "ICON"          => "The file icon",
             "FILE_LBL"      => "The file name label"
             ),
        "10" => array(
             "TITLE"         => "Indicates where the page title should appear (Required)",
             "CHARSET"       => "The character set from the users language pack (Required)",
             "COPYRIGHT"     => "Indicated where the copyright should be placed (Required)",
             "SOURCE"        => "The file content (Required)",
             "FILE"          => "The file name",
             "CLOSE"         => "The text for the close window button",
             "GZIP"          => "The marker to display the gzip compression status",
             "STATS"         => "Where to display the script page generation times"
             ),
        "11" => array(
             "TITLE"         => "Indicates where the page title should appear (Required)",
             "CHARSET"       => "The character set from the users language pack (Required)",
             "JAVASCRIPT"    => "Indicates where the javascript should be placed (Required)",
             "COPYRIGHT"     => "Indicated where the copyright should be placed (Required)",
             "F"             => "The file name (Required)",
             "DIR"           => "The directory name (Required)",
             "RUN"           => "The text for the submit button (Required)",
             "CHECK1"        => "The Owner/Read Permission (Required)",
             "CHECK4"        => "The Group/Read Permission (Required)",
             "CHECK7"        => "The Public/Read Permission (Required)",
             "CHECK2"        => "The Owner/Write Permission (Required)",
             "CHECK5"        => "The Group/Write Permission (Required)",
             "CHECK8"        => "The Public/Write Permission (Required)",
             "CHECK3"        => "The Owner/Execute Permission (Required)",
             "CHECK6"        => "The Group/Execute Permission (Required)",
             "CHECK9"        => "The Public/Execute Permission (Required)",
             "CHMOD"         => "The octual CHMOD value (Required)",
             "FILE"          => "The file name and path",
             "CLOSE"         => "The text for the close window button",
             "OWNER"         => "The owner label",
             "GROUP"         => "The group label",
             "PUBLIC"        => "The public label",
             "READ"          => "The read label",
             "WRITE"         => "The write label",
             "EXECUTE"       => "The execute label",
             "OCTUAL"        => "The octual label",
             "GZIP"          => "The marker to display the gzip compression status",
             "STATS"         => "Where to display the script page generation times"
             ),
        "12" => array(
             "TITLE"         => "Indicates where the page title should appear (Required)",
             "CHARSET"       => "The character set from the users language pack (Required)",
             "JAVASCRIPT"    => "Indicates where the javascript should be placed (Required)",
             "COPYRIGHT"     => "Indicated where the copyright should be placed (Required)",
             "THIS_DIR"      => "The current directory (Required)",
             "NAV"           => "The navigation bar (Required)",
             "O_DIR"         => "The original directory (Required)",
             "O_FILE"        => "The original file (Required)",
             "ACT"           => "The action (Required)",
             "DIR"           => "The directory name (Required)",
             "CLOSE"         => "The text for the close button",
             "UP"            => "The &quot;Up one directory&quot; link",
             "UP_ALT"        => "The &quot;Up one directory&quot; alt text",
             "NAME"          => "The directory name",
             "LINK"          => "The directory links",
             "GO"            => "The &quot;Go&quot; button",
             "GZIP"          => "The marker to display the gzip compression status",
             "STATS"         => "Where to display the script page generation times"
             ),
        "13" => array(
             "TITLE"         => "Indicates where the page title should appear (Required)",
             "CHARSET"       => "The character set from the users language pack (Required)",
             "JAVASCRIPT"    => "Indicates where the javascript should be placed (Required)",
             "COPYRIGHT"     => "Indicated where the copyright should be placed (Required)",
             "DIR"           => "The directory name (Required)",
             "FILENAME"      => "The filename (Required)",
             "USER_LIST"     => "The drop down list of users (Required)",
             "EDIT"          => "The text for the edit button (Required)",
             "DELETE"        => "The text for the delete button (Required)",
             "CREATE"        => "The text for the create button (Required)",
             "NEW"           => "New users caption",
             "USER"          => "Username caption",
             "PASS"          => "Password caption",
             "FILE"          => "The name of the file",
             "CLOSE"         => "The text for the close button",
             "GZIP"          => "The marker to display the gzip compression status",
             "STATS"         => "Where to display the script page generation times"
             ),
        "14" => array(
             "AREAS"         => "The area buttons such as Log out (Required)",
             "MAIN"          => "The form action (Required)",
             "SUBMIT"        => "The text used on the submit button (Required)",
             "TITLE"         => "The page heading",
             "NAME_LBL"      => "The file name label"
             ),
        "15" => array()
        );

// The final array contains any special information on each template, such as a "tip" or "hint"
$info = array(
        "1"  => "Please do not remove the copyright information, or make it difficult to read. Doing so is illegal.<br />The reason we allow you to edit this information so easily is so that you can modify the font to suit your site, please do not abuse this power",
        "2"  => "There are many forms on this page.<br />There is no place markers shown for the icon legend as this is system dependent, to show these just use the text you added to the language pack, for example if you added new_icon then use &#123;NEW_ICON&#125; to show it's text<br /><br />Remember to leave the comments in for each dynamic block otherwise they will not be parsed correctly",
        "3"  => "Leave the select code intact, changing it may cause problems",
        "4"  => "Leave the select code intact, changing it may cause problems",
        "5"  => "The error message is taken directly from MySQL and so cannot be changed via the Language pack",
        "6"  => "",
        "7"  => "",
        "8"  => "Please note that two password fields with the names newpass and newpass2 are required",
        "9"  => "This page uses a lot of form fields, please be careful when editing it",
        "10" => "This file does not use the global template as it opens in a seperate window",
        "11" => "This file does not use the global template as it opens in a seperate window",
        "12" => "This file does not use the global template as it opens in a seperate window<br /><br />Remember to leave the comments in for the dynamic block otherwise the template will not be parsed correctly",
        "13" => "This file does not use the global template as it opens in a seperate window<br /><br />Remember to leave the comments in for the dynamic block otherwise the template will not be parsed correctly",
        "14" => "Remember to leave the comments in for the dynamic block otherwise the template will not be parsed correctly",
        "15" => "This file is a standard CSS file"
        );

// The next 2 arrays contain "parser" data i.e. data used to update the template

// An array of the "place markers" required for each template
$required = array(
        "1"  => array("TITLE", "JAVASCRIPT", "CONTENT", "COPYRIGHT", "CHARSET"),
        "2"  => array("MSG", "NAV", "AREAS"),
        "3"  => array("THIS", "INSTRUCTIONS", "SUBMIT"),
        "4"  => array("THIS", "SUBMIT", "AREAS"),
        "5"  => array("AREAS", "ERR_MSG"),
        "6"  => array("DB", "THIS", "AREAS", "RESULT"),
        "7"  => array("AREAS", "IMG"),
        "8"  => array("AREAS", "THIS", "SUBMIT"),
        "9"  => array("AREAS", "THIS", "NEXT_DIR", "IS_NEW", "FILENAME", "FDATA", "SUBMIT", "WRAP"),
        "10" => array("TITLE", "SOURCE", "COPYRIGHT", "CHARSET"),
        "11" => array("TITLE", "CHARSET", "JAVASCRIPT", "COPYRIGHT", "F", "DIR", "RUN", "CHECK1", "CHECK2", "CHECK3", "CHECK4", "CHECK5", "CHECK6", "CHECK7", "CHECK8", "CHECK9", "CHMOD"),
        "12" => array("TITLE", "CHARSET", "JAVASCRIPT", "COPYRIGHT", "THIS_DIR", "NAV", "O_DIR", "O_FILE", "ACT", "DIR"),
        "13" => array("TITLE", "CHARSET", "JAVASCRIPT", "COPYRIGHT", "DIR", "FILENAME", "USER_LIST", "EDIT", "DELETE", "CREATE"),
        "14" => array("AREAS", "MAIN", "SUBMIT"),
        "15" => array()
        );

// This array is the name of the file to use for each template
$files = array(
        "1"  => "/settings/templates/global.tpl",
        "2"  => "/settings/templates/index.tpl",
        "3"  => "/settings/templates/login.tpl",
        "4"  => "/settings/templates/mysql.tpl",
        "5"  => "/settings/templates/mysql_err.tpl",
        "6"  => "/settings/templates/result.tpl",
        "7"  => "/settings/templates/space.tpl",
        "8"  => "/settings/templates/pwd.tpl",
        "9"  => "/settings/templates/edit.tpl",
        "10" => "/settings/templates/source.tpl",
        "11" => "/settings/templates/chmod.tpl",
        "12" => "/settings/templates/move.tpl",
        "13" => "/settings/templates/lock.tpl",
        "14" => "/settings/templates/upload.tpl",
        "15" => "/settings/templates/styles.css"
        );
?>