<?php

/*
 * Invision Power File Manager
 * File Templates Manager
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 3rd March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

// Include the language data
if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("language settings file");
}
if (!(include($script_dir . "/languages/" . $lang_file[$default_lang] . ".lng.php")))
{
    include_error($lang_name[$default_lang] . " language pack");
}

// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

$header = "<?php\r\n\r\n";
$header .= "/*\r\n";
$header .= " * Invision Power File Manager\r\n";
$header .= " * Templates Configuration Script\r\n";
$header .= " * Copyright (c) 2003 Invision Power Services\r\n";
$header .= " * -------------------------------------\r\n";
$header .= " * You may not remove the copyright or\r\n";
$header .= " * redistribute the script in any form\r\n";
$header .= " *\r\n";
$header .= " * Authors: Stephen Ball <stephen@invisionfilemanager.com>\r\n";
$header .= " *\r\n";
$header .= " */\r\n\r\n";

if ($op == "new")
{
    // Display the new template form
    $pagetitle = "Create a New File Template";

    $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" name=\"template\">\r\n";
    $form .= "<input type=\"hidden\" name=\"op\" value=\"create\">\r\n";
    $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>File Extension:</b></font></td>\r\n";
    $form .= "        <td align=\"left\"><input type=\"text\" name=\"ext\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No dot (.) needed, i.e cpp</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Name:</b></font></td>\r\n";
    $form .= "        <td align=\"left\"><input type=\"text\" name=\"name\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Used for the file name, i.e cplusplus would make the file cplusplus.tpl</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Description:</b></font></td>\r\n";
    $form .= "        <td align=\"left\"><input type=\"text\" name=\"description\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Displayed in the list of templates, i.e. C++ Script</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td valign=\"top\" valign=\"top\" align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Content:</b></font></td>\r\n";
    $form .= "        <td align=\"left\"><textarea wrap=\"soft\" name=\"fdata\" style=\"width: 90%\" rows=\"25\"></textarea><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The actual template content</font></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "    <tr>\r\n";
    $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Save Template\">  <input type=\"button\" value=\"Disable Wrapping\" name=\"wrapping\" onclick=\"javascript:wrap();\"></td>\r\n";
    $form .= "    </tr>\r\n";
    $form .= "</table>\r\n";
    $form .= "</form>\r\n";

    $data = msg($form, $pagetitle); 
}
else if ($op == "create")
{
    $pagetitle = "Create New Template";

    if (param("ext", "POST") == "" || param("description", "POST") == "" || param("name", "POST") == "" || param("fdata", "POST") == "")
    {
        // The template data isn't complete
        $data = msg("A required field is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (eregi("[\\\/:*?\"<>|]", param("name", "POST")) == TRUE || eregi("[\\\/:*?\"<>|]", param("ext", "POST")) == TRUE)
    {
        // The file name contains invalid characters
        $data = msg("The template name or extension contains an invalid character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (in_array(trim(param("ext", "POST")), $temp_extension) == TRUE)
    {
        // The template extension already exists
        $data = msg("Sorry but a template with that extension already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else if (in_array(trim(param("name", "POST")), $temp_name) == TRUE)
    {
        // The template name already exists
        $data = msg("Sorry but a template with that name already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else if (in_array(trim(param("description", "POST")), $temp_description) == TRUE)
    {
        // The template description already exists
        $data = msg("Sorry but a template with that description already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else
    {
        // Get the post data
        $fdata          = param("fdata", "POST");
        $ext            = param("ext", "POST");
        $description    = param("description", "POST");
        $name           = param("name", "POST");

        // Strip slashes if needed 
        if (get_magic_quotes_gpc() == FALSE)
        {
            $ext            = addslashes($ext);
            $description    = addslashes($description);
            $name           = addslashes($name);
        }

        // Add the new values to the end of the arrays
        $temp_description[] = $description;
        $temp_extension[]   = $ext;
        $temp_name[]        = $name;

        // Begin building up the data
        $str = $header;
        $str .= build_array($temp_extension, "temp_extension") . "\r\n";
        $str .= build_array($temp_name, "temp_name") . "\r\n";
        $str .= "?" . ">";
        
        if (($fp = fopen($script_dir . "/templates/" . $name . ".tpl", "w")) == FALSE)
        {
            // The new template couldn't be created
            $msg = "The new template could not be created, ensure that the directory &quot;" . $script_dir . $slash . "templates" . $slash . "&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
            $title = "Server Error";
        }
        else
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }
        
            // The file was opened and locked so write the data
            fwrite($fp, $fdata);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN);
            }
        
            fclose($fp);
            chmod($script_dir . "/templates/" . $name . ".tpl", 0777);

            if (($fp = fopen($script_dir . "/settings/templates.inc.php", "w")) == FALSE)
            {
                $msg = "The new template details could not be added, ensure that the file &quot;" . $script_dir . $slash . "settings" . $slash . "templates.inc.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
                $title = "Server Error";

                // Delete the new template
                unlink($script_dir . "/templates/" . $name . ".tpl");
            }
            else
            {
                // The file was opened, now to lock it
                if ($flock == TRUE)
                {
                    flock($fp, LOCK_EX);
                }
        
                $str = clean_crlf($str);

                // The file was opened and locked so write the data
                fwrite($fp, $str);
                if ($flock == TRUE)
                {
                    flock($fp, LOCK_UN);
                }
        
                fclose($fp);

                if (rebuild_lang_pack($lang_file[$default_lang]) == FALSE)
                {
                    // The language pack could not be rebuilt!
                    $msg = "The language pack could not be rebuilt, ensure that the file &quot;" . $script_dir . $slash . "languages" . $slash . $lang_file[$default_lang] . ".lng.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
                    $title = "Server Error";

                    // Delete the new template file
                    unlink($script_dir . "/templates/" . $name . ".tpl");

                    // Remove the new items
                    array_pop($temp_extension);
                    array_pop($temp_name);

                    // Rebuild the templates testings!
                    $str = $header;
                    $str .= build_array($temp_extension, "temp_extension") . "\r\n";
                    $str .= build_array($temp_name, "temp_name") . "\r\n";
                    $str .= "?" . ">";
                    
                    $str = clean_crlf($str);

                    $fp = fopen($script_dir . "/settings/templates.inc.php", "w");
                    fwrite($fp, $str);
                    fclose($fp);
                }
                else
                {
                    $msg = "The new template has been created!";
                    $title = $pagetitle;
                }
            }
        }

        $data = msg($msg, $title);
    }
}
else if ($op == "del" || $op == "edit")
{
    $first = 0;

    if ($op == "del")
    {
        $next       = "remove";
        $submit     = "Delete Template";
        $pagetitle  = "Delete an Existing Template";
    }
    else
    {
        $next       = "change";
        $submit     = "Edit Template";
        $pagetitle  = "Edit an Existing Template";
    }

    if (count($temp_description) == 0)
    {
        $data = msg("There are no templates available");
    }
    else
    {
        $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
        $form .= "<input type=\"hidden\" name=\"op\" value=\"" . $next . "\">\r\n";
        $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please select a template from the list below</font></td>\r\n";
        $form .= "    </tr>\r\n";
    
        
        natcasesort($temp_description);

        // List the template
        foreach ($temp_description as $key => $var)
        {
            if ($key != 0)
            {
                // We don't want to show the entry for the blank text document, so ignore item 0
                
                $form .= "    <tr>\r\n";
                if ($first == 0)
                {
                    // Make sure the first template is checked
                    $first = 1;
                    $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"template\" value=\"" . $key . "\" checked=\"checked\"/></td>\r\n";
                }   
                else
                {
                    $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"template\" value=\"" . $key . "\" /></td>\r\n";
                }
                $form .= "        <td><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $var . "</font></td>\r\n";
                $form .= "    </tr>\r\n";               
            }
        }

        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"" . $submit . "\"></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "</table>\r\n";

        $data = msg($form, $pagetitle);
    }
}
else if ($op == "change")
{
    // Display the edit template form
    $pagetitle = "Edit an Existing File Template";

    $id = param("template", "POST");

    if (($fp = fopen($script_dir . "/templates/" . $temp_name[$id] . ".tpl", "r")) == FALSE)
    {
        $form = "There was an error opening the template file &quot;" . $script_dir . $slash . "templates" . $slash . $temp_name[$id] . ".tpl&quot;, please ensure that it is readable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
    }
    else
    {
        $fdata = fread($fp, filesize($script_dir . "/templates/" . $temp_name[$id] . ".tpl"));
        fclose($fp);

        $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\" name=\"template\">\r\n";
        $form .= "<input type=\"hidden\" name=\"op\" value=\"update\">\r\n";
        $form .= "<input type=\"hidden\" name=\"id\" value=\"" . $id . "\">\r\n";
        $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>File Extension:</b></font></td>\r\n";
        $form .= "        <td align=\"left\"><input type=\"text\" value=\"" . $temp_extension[$id] . "\" name=\"ext\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No dot (.) needed, i.e cpp</font></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Name:</b></font></td>\r\n";
        $form .= "        <td align=\"left\"><input type=\"text\" value=\"" . $temp_name[$id] . "\"name=\"name\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Used for the file name, i.e cplusplus would make the file cplusplus.tpl</font></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Description:</b></font></td>\r\n";
        $form .= "        <td align=\"left\"><input type=\"text\" value=\"" . $temp_description[$id] . "\"name=\"description\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Displayed in the list of templates, i.e. C++ Script</font></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td valign=\"top\" valign=\"top\" align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Content:</b></font></td>\r\n";
        $form .= "        <td align=\"left\"><textarea wrap=\"soft\" name=\"fdata\" style=\"width: 90%\" rows=\"25\">" . $fdata . "</textarea><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">The actual template content</font></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"Save Template\">  <input type=\"button\" value=\"Disable Wrapping\" name=\"wrapping\" onclick=\"javascript:wrap();\"></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "</table>\r\n";
        $form .= "</form>\r\n";
    }

    $data = msg($form, $pagetitle); 
}
else if ($op == "update")
{
    $pagetitle = "Update an Existing Template";

    $id        = param("id", "POST");

    if (param("ext", "POST") == "" || param("description", "POST") == "" || param("name", "POST") == "" || param("fdata", "POST") == "")
    {
        // The template data isn't complete
        $data = msg("A required field is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (eregi("[\\\/:*?\"<>|]", param("name", "POST")) == TRUE || eregi("[\\\/:*?\"<>|]", param("ext", "POST")) == TRUE)
    {
        // The file name contains invalid characters
        $data = msg("The template name or extension contains an invalid character<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (in_array(trim(param("ext", "POST")), $temp_extension) == TRUE && param("ext", "POST") != $temp_extension[$id])
    {
        // The template extension already exists
        $data = msg("Sorry but a template with that extension already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else if (in_array(trim(param("name", "POST")), $temp_name) == TRUE && param("name", "POST") != $temp_name[$id])
    {
        // The template name already exists
        $data = msg("Sorry but a template with that name already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else if (in_array(trim(param("description", "POST")), $temp_description) == TRUE && param("description", "POST") != $temp_description[$id])
    {
        // The template description already exists
        $data = msg("Sorry but a template with that description already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new extension</a>");
    }
    else
    {
        // Get the post data
        $fdata          = param("fdata", "POST");
        $ext            = param("ext", "POST");
        $description    = param("description", "POST");
        $name           = param("name", "POST");

        // Strip slashes if needed 
        if (get_magic_quotes_gpc() == FALSE)
        {
            $ext            = addslashes($ext);
            $description    = addslashes($description);
            $name           = addslashes($name);
        }

        // Get the old details
        $oldname            = $temp_name[$id];
        $oldext             = $temp_extension[$id];
        $olddescription     = $temp_description[$id];

        // Remove the values from the arrays
        foreach($temp_description as $key => $var)
        {
            if ($key == $id)
            {
                $new_temp_description[$key] = $description;
            }
            else
            {
                $new_temp_description[$key] = $var;
            }
        }
        $temp_description = $new_temp_description;

        foreach($temp_extension as $key => $var)
        {
            if ($key == $id)
            {
                $new_temp_extension[$key] = $ext;
            }
            else
            {
                $new_temp_extension[$key] = $var;
            }
        }

        foreach($temp_name as $key => $var)
        {
            if ($key == $id)
            {
                $new_temp_name[$key] = $name;
            }
            else
            {
                $new_temp_name[$key] = $var;
            }
        }
        
        // Begin building up the data
        $str = $header;
        $str .= build_array($new_temp_extension, "temp_extension") . "\r\n";
        $str .= build_array($new_temp_name, "temp_name") . "\r\n";
        $str .= "?" . ">";
        
        if (($fp = fopen($script_dir . "/templates/" . $oldname . ".tpl", "w")) == FALSE)
        {
            // The new template couldn't be edited
            $msg = "The template could not be edited, ensure that the directory &quot;" . $script_dir . $slash . "templates" . $slash . "&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
            $title = "Server Error";
        }
        else
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }
            
            $fdata = clean_crlf($fdata);

            // The file was opened and locked so write the data
            fwrite($fp, $fdata);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN);
            }
        
            fclose($fp);
            chmod($script_dir . "/templates/" . $name . ".tpl", 0777);

            if (rename($script_dir . "/templates/" . $oldname . ".tpl", $script_dir . "/templates/" . $name . ".tpl") == FALSE)
            {
                $msg = "The template could not be renamed, ensure that the file &quot;" . $script_dir . $slash . "templates" . $slash . $oldname . ".tpl&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
                $title = "Server Error";
            }
            else
            {
                if (($fp = fopen($script_dir . "/settings/templates.inc.php", "w")) == FALSE)
                {
                    $msg = "The template details could not be updated, ensure that the file &quot;" . $script_dir . $slash . "settings" . $slash . "templates.inc.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
                    $title = "Server Error";

                    // Reset the file name
                    rename($script_dir . "/templates/" . $name . ".tpl", $script_dir . "/templates/" . $oldname . ".tpl");
                }
                else
                {
                    // The file was opened, now to lock it
                    if ($flock == TRUE)
                    {
                        flock($fp, LOCK_EX);
                    }
        
                    $str = clean_crlf($str);

                    // The file was opened and locked so write the data
                    fwrite($fp, $str);
                    if ($flock == TRUE)
                    {
                        flock($fp, LOCK_UN);
                    }
        
                    fclose($fp);

                    if (rebuild_lang_pack($lang_file[$default_lang]) == FALSE)
                    {
                        // The language pack could not be rebuilt!
                        $msg = "The language pack could not be rebuilt, ensure that the file &quot;" . $script_dir . $slash . "languages" . $slash . $lang_file[$default_lang] . ".lng.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
                        $title = "Server Error";
    
                        // Reset the file name
                        rename($script_dir . "/templates/" . $name . ".tpl", $script_dir . "/templates/" . $oldname . ".tpl");

                        // Rebuild the templates settings!
                        $str = $header;
                        $str .= build_array($temp_extension, "temp_extension") . "\r\n";
                        $str .= build_array($temp_name, "temp_name") . "\r\n";
                        $str .= "?" . ">";
                        
                        $str = clean_crlf($str);

                        $fp = fopen($script_dir . "/settings/templates.inc.php", "w");
                        fwrite($fp, $str);
                        fclose($fp);
                    }
                    else
                    {
                        $msg = "The existing template has been updated";
                        $title = $pagetitle;
                    }
                }
            }
        }

        $data = msg($msg, $title);
    }
}
else if ($op == "remove")
{
    $pagetitle = "Remove an Existing Template";
    $id        = param("template", "POST");

    // Get the old details
    $oldname   = $temp_name[$id];

    // Remove the values from the arrays
    foreach($temp_description as $key => $var)
    {
        if ($key != $id)
        {
            $new_temp_description[$key] = $var;
        }
    }
    $temp_description = $new_temp_description;

    foreach($temp_extension as $key => $var)
    {
        if ($key != $id)
        {
            $new_temp_extension[$key] = $var;
        }
    }

    foreach($temp_name as $key => $var)
    {
        if ($key != $id)
        {
            $new_temp_name[$key] = $var;
        }
    }
        
    // Begin building up the data
    $str = $header;
    $str .= build_array($new_temp_extension, "temp_extension") . "\r\n";
    $str .= build_array($new_temp_name, "temp_name") . "\r\n";
    $str .= "?" . ">";
        
    chmod($script_dir . "/templates/" . $oldname . ".tpl", 0777);

    if (($fp = fopen($script_dir . "/settings/templates.inc.php", "w")) == FALSE)
    {
        $msg = "The template details could not be removed, ensure that the file &quot;" . $script_dir . $slash . "settings" . $slash . "templates.inc.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
        $title = "Server Error";
    }
    else
    {
        if (rebuild_lang_pack($lang_file[$default_lang]) == FALSE)
        {
            // The language pack could not be rebuilt!
            $msg = "The language pack could not be rebuilt, ensure that the file &quot;" . $script_dir . $slash . "languages" . $slash . $lang_file[$default_lang] . ".lng.php&quot; is writible<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and try again</a>";
            $title = "Server Error";
    
            // Rebuild the templates settings!
            $str = $header;
            $str .= build_array($temp_extension, "temp_extension") . "\r\n";
            $str .= build_array($temp_name, "temp_name") . "\r\n";
            $str .= "?" . ">";

            $str = clean_crlf($str);

            $fp = fopen($script_dir . "/settings/templates.inc.php", "w");
            fwrite($fp, $str);
            fclose($fp);
        }
        else
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }

            $str = clean_crlf($str);

            // The file was opened and locked so write the data
            fwrite($fp, $str);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN);
            }
        
            fclose($fp);

            if (unlink($script_dir . "/templates/" . $oldname . ".tpl") == FALSE)
            {
                // The template couldn't be removed
                $msg = "The template has been removed from the system but a file could not be removed, you should remove the file &quot;" . $script_dir . $slash . "templates" . $slash . $oldname . ".tpl&quot;<br /><br />Also remember to rebuild your other language packs";
            }
            else
            {
                $msg = "The template has been removed";
            }

            $title = $pagetitle;
        }
    }

    $data = msg($msg, $title);
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>