<?php

/*
 * Invision Power File Manager
 * User Manager
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 4th March 2003 
 *
 */

error_reporting(0);

if (!(include("./header.lib.php")))
{
    die("<p align=\"center\">There was an error loading the header module</p>");
}

if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("There was an error loading the language settings file");
}

// Get the $op variable
$op = param("op", "GET");
if (empty($op))
{
    $op = param("op", "POST");
}

if ($op == "del" || $op == "edit")
{
    // Need to check for only 1 (on delete) or 0 entries
    $userlist = file($script_dir . "/settings/" . $scripts["userlist"]);
    $first = 0;

    if ($op == "del")
    {
        $next       = "remove";
        $submit     = "Delete Account";
        $pagetitle  = "Delete an Existing User";
    }
    else
    {
        $next       = "change";
        $submit     = "Edit Account";
        $pagetitle  = "Edit an Existing User";
    }

    if (count($userlist) == 0)
    {
        $data = msg("There are no users available");
    }
    else if (count($userlist) == 1 && $op == "del")
    {
        $data = msg("You cannot delete the last user account");
    }
    else
    {
        $form = "<form action=\"" . $PHP_SELF ."\" method=\"post\">\r\n";
        $form .= "<input type=\"hidden\" name=\"op\" value=\"" . $next . "\">\r\n";
        $form .= "<table width=\"100%\" border=\"0\" cellpadding=\"2\" cellspacing=\"1\">\r\n";
        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please select a user from the list below</font></td>\r\n";
        $form .= "    </tr>\r\n";
    
        // List the users
        while(list(,$value) = each($userlist))
        {
            if ($value != "")
            {
                list($username, $password, $htpasswd, $changepass, $chmod, $upload, $rename, $edit, $delete, $copy, $move, $newfolder, $newfile, $overwrite, $compress, $mysql, $dbhost, $dbuser, $dbpass, $dbname, $root_url, $root_dir, $max_space, $lang) = split("[|]", $value);
        
                $form .= "    <tr>\r\n";
                if ($first == 0)
                {
                    // Make sure the first user is checked
                    $first = 1;
                    $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"user\" value=\"" . $username . "\" checked=\"checked\"/></td>\r\n";
                }   
                else
                {
                    $form .= "        <td width=\"1%\"><input type=\"radio\" name=\"user\" value=\"" . $username . "\" /></td>\r\n";
                }
                $form .= "        <td><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $username . "</font></td>\r\n";
                $form .= "    </tr>\r\n";
            }
        }

        if ($op == "del")
        {

            $form .= "    <tr>\r\n";
            $form .= "        <td colspan=\"2\" align=\"center\">&nbsp;</td>\r\n";
            $form .= "    </tr>\r\n";
            $form .= "    <tr>\r\n";
            $form .= "        <td width=\"1%\"><input type=\"checkbox\" value=\"1\" name=\"rmdir\" /></td>\r\n";
            $form .= "        <td><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Delete the users directory</font></td>\r\n";
            $form .= "    </tr>\r\n";
        }

        $form .= "    <tr>\r\n";
        $form .= "        <td colspan=\"2\" align=\"center\"><input type=\"submit\" value=\"" . $submit . "\"></td>\r\n";
        $form .= "    </tr>\r\n";
        $form .= "</table>\r\n";

        $data = msg($form, $pagetitle);
    }
}
else if ($op == "remove")
{
    $pagetitle  = "Delete an Existing User";
    $user       = param("user", "POST");
    $rmdir      = param("rmdir", "POST");

    // Remove the user
    if (($params = find_user($user)) == FALSE)
    {
        // The user doesn't exist, what is the admin trying to do?
        $data = msg("Sorry but you did not select a valid user<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and select a valid user</a>");
    }
    else
    {
        $fdata      = "";
        $userlist   =  file($script_dir . "/settings/" . $scripts["userlist"]);

        // Navigate through the user list
        while(list(,$value) = each($userlist))
        {
            if ($value != "")
            {
                list($username, $password, $htpasswd, $changepass, $chmod, $upload, $rename, $edit, $delete, $copy, $move, $newfolder, $newfile, $overwrite, $compress, $mysql, $dbhost, $dbuser, $dbpass, $dbname, $root_url, $root_dir, $max_space, $lang) = split("[|]", $value);

                $lang = trim($lang);
                if($username != $user)
                {
                    // The record is not the selected users record so don't remove it
                    $fdata .= "$username|$password|$htpasswd|$changepass|$chmod|$upload|$rename|$edit|$delete|$copy|$move|$newfolder|$newfile|$overwrite|$compress|$mysql|$dbhost|$dbuser|$dbpass|$dbname|$root_url|$root_dir|$max_space|$lang\r\n";
                }
            }
        }

        // Set a default message
        $data = msg("There was an unknown error deleting the new account. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . $scripts["userlist"] . "&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");

        if(($fp = fopen($script_dir . "/settings/" . $scripts["userlist"], "w")) == TRUE)
        {
            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }
        
            $fdata = clean_crlf($fdata);

            // The file was opened and locked so write the data
            fwrite($fp, $fdata);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN); // Unlock
            }
  		    fclose($fp);

            $remove = "";
            if ($rmdir == 1)
            {
                $remove = (remove_dir($params["root"]) == TRUE && rmdir($params["root"]) == TRUE) ? "<br />The users root directory was deleted" : "<br />The users root directory could not be deleted, you should do this by hand";
            }

            // The user was created!
            $data = msg("The user has been deleted successfully" . $remove, "User Account Deleted");
        }  
    }
}
else if ($op == "change")
{
    $pagetitle  = "Edit an Existing User";
    $user       = param("user", "POST");

    // Edit the user
    if (($params = find_user($user)) == FALSE)
    {
        // The user doesn't exist, what is the admin trying to do?
        $data = msg("Sorry but you did not select a valid user<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and select a valid user</a>");
    }
    else
    {
        // Build the language drop down list
        $langauges[0] = "System Default";
        foreach ($lang_name as $key => $var)
        {
            $langauges[$key] = $var;
        }
        $lang_list = dropdown($langauges, $params["lang"]);
        $space     = space_dropdown($params["space"]);

        $data = "<table border=\"0\" width=\"85%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
        $data .= "	<tr>\r\n";
        $data .= "		<th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\">Edit User</font></th>\r\n";
        $data .= "	</tr>\r\n";
        $data .= "	<tr>\r\n";
        $data .= "		<td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\">\r\n";
        $data .= "	    <form action=\"$PHP_SELF\" method=\"post\">\r\n";
        $data .= "		<input type=\"hidden\" name=\"op\" value=\"update\" />\r\n";
        $data .= "		<input type=\"hidden\" name=\"user\" value=\"" . $user . "\" />\r\n";
        $data .= "			<table border=\"0\" width=\"100%\" cellpadding=\"3\">\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"center\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please enter the users details below</font></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Access Details</i></font></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Username</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $params["name"] . "</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Password</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"password\" style=\"width: 90%\" /></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Retype Password</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"password2\" style=\"width: 90%\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\">&nbsp;</td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Leave the above fields blank to keep the current password</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>User Permissions</i><br /><br />The user can....</font></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>&quot;Lock&quot; a directory?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("lock", $params["htpasswd"]) . "<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Apache  Only</font></td>\r\n";
        $data .= "		        </tr>\r\n";
        $data .= "			    <tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Change their own password?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("chpass", $params["change"]) ."</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>CHMOD files or folders?</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\">" . checkbox("chmod", $params["CHMOD"]) . "<font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Unix based systems only</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Upload files?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("upload", $params["upload"]) . "</td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Rename existing files or folders?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("rename", $params["rename"]) . "</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Edit existing files?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("edit", $params["edit"]) . "</td>\r\n";
        $data .= "			    </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Delete existing files or folders?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("delete", $params["delete"]) . "</td>\r\n";
        $data .= "		        </tr>\r\n";
        $data .= "			    <tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Use &quot;Copy To&quot;?</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\">" . checkbox("copy", $params["copy"]) . "</td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Use &quot;Move To&quot;?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("move", $params["move"]) . "</td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create new folders?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("mkdir", $params["newfolder"]) . "</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create new files?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("mkfile", $params["newfile"]) . "</td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Overwrite existing files?</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\">" . checkbox("overwrite", $params["overwrite"]) . "</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create Zip archives?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("zip", $params["compress"]) . " <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Zlib extension required</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr align=\"center\">\r\n";
        $data .= "				    <td colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\" align=\"center\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>MySQL Settings</i></font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Allow access to MySQL?</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\">" . checkbox("mysql", $params["mysql"]) . "</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Server</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbserver\" value=\"" . $params["dbhost"] . "\" style=\"width: 90%\" /></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Username</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbuser\" value=\"" . $params["dbuser"] . "\" style=\"width: 90%\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Password</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbpass\" value=\"" . $params["dbpass"] . "\" style=\"width: 90%\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Databases</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbs\" value=\"" . $params["dbname"] . "\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Comma seperated list of databases</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\" align=\"center\" /></td>\r\n";
        $data .= "				</tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Other Settings</i></font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"> <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Root Directory</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $params["root"] . "\" name=\"rootdir\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Trailing slash required</font></td>\r\n";
        $data .= "			    </tr>\r\n";
        $data .= "				<tr>\r\n";
        $data .= "					<td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Root URL</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" value=\"" . $params["root_url"] . "\" name=\"rooturl\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No trailing slash required</font></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Space Limit</b></font></td>\r\n";
        $data .= "					<td align=\"left\" width=\"85%\">" . $space . "</td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "		        <tr>\r\n";
        $data .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Default Language</b></font></td>\r\n";
        $data .= "		            <td align=\"left\" width=\"85%\"><select name=\"lang\">" . $lang_list .  "</select></td>\r\n";
        $data .= "			    </tr>\r\n";
        $data .= "				<tr> \r\n";
        $data .= "					<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Update Account\" /></td>\r\n";
        $data .= "	            </tr>\r\n";
        $data .= "			</table>\r\n";
        $data .= "		    </form>\r\n";
        $data .= "		</td>\r\n";
        $data .= "	</tr>\r\n";
        $data .= "</table>\r\n";
    }
}
else if ($op == "update")
{
    $pagetitle = "Update User Account";

    $u_username = param("user", "POST");

    if (($params = find_user($u_username)) == FALSE)
    {
        // The user doesn't exist, what is the admin trying to do?
        $data = msg("Sorry but you did not select a valid user<br /><br /><a href=\"users.php?op=edit\">&laquo; Go back and select a valid user</a>");
    }
    else
    {
        // Get the Access details
        $u_password   = trim(param("password", "POST", 1));
        $u_password2  = trim(param("password2", "POST", 1));

        // Get the Permissions
        $u_lock       = param("lock", "POST");
        $u_chpass     = param("chpass", "POST");
        $u_chmod      = param("chmod", "POST");
        $u_upload     = param("upload", "POST");
        $u_rename     = param("rename", "POST");
        $u_edit       = param("edit", "POST");
        $u_delete     = param("delete", "POST");
        $u_copy       = param("copy", "POST");
        $u_move       = param("move", "POST");
        $u_mkdir      = param("mkdir", "POST");
        $u_mkfile     = param("mkfile", "POST");
        $u_overwrite  = param("overwrite", "POST");
        $u_zip        = param("zip", "POST");

        // Get the MySQL details
        $u_mysql      = param("mysql", "POST");
        $u_dbserver   = param("dbserver", "POST", 1);
        $u_dbuser     = param("dbuser", "POST", 1);
        $u_dbpass     = param("dbpass", "POST", 1);
        $u_dbs        = param("dbs", "POST", 1);

        // Ensure there are no spaces or trailing ,
        $db = explode(",", $u_dbs);
        $dbs = "";
        foreach($db as $var)
        {
            $dbs .= trim($var) . ",";
        }
        $u_dbs = preg_replace("/,+$/", "", $dbs);

        // Get the other settings
        $u_rootdir    = trim(param("rootdir", "POST", 1));
        $u_rooturl    = trim(param("rooturl", "POST", 1));
        $u_space      = trim(param("space", "POST", 1));
        $u_type       = param("type", "POST");
        $u_lang       = param("lang", "POST");

        if ($u_password != "" && strlen($u_password) < 5 && $u_username != "guest")
        {
            // The password is too short
            $data = msg("Sorry but the password must be at least 5 characters long<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
        }
        else if ($u_password != "" && $u_password != $u_password2 && $u_username != "guest")
        {
            // The passwords do not match
            $data = msg("Sorry but the passwords you entered do not match<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
        }
        else if ($u_mysql == 1 && (empty($u_dbserver) || empty($u_dbuser) || empty($u_dbpass) || empty($u_dbs)))
        {
            // The admin has given the user MySQL access but didn't enter any details
            $data = msg("You have selected to allow the user to access MySQL but you have not entered their &quot;<i>MySQL Settings</i>&quot;<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
        }
        else if (empty($u_rootdir) || empty($u_rooturl) || empty($u_space))
        {
            // A required field is missing
            $data = msg("A required field from the &quot;<i>Other Settings</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and fill in the missing fields</a>");
        }
        else
        {
            // All fields are valid, now update the data
            // Work out the maximum space in bytes
            if ($u_type == 2)
            {
                $u_type = 1024;
            }
            else if ($u_type == 3)
            {
                $u_type = 1048576;
            }
            else if ($u_type == 4)
            {
                $u_type = 1073741824;
            }
            else
            {
                $u_type = 1;
            }
         
            $u_space = (int) $u_space * $u_type;

            // Work out the actual values
            $u_lock       = $u_lock         == 1 ? 1 : 0;
            $u_chpass     = $u_chpass       == 1 ? 1 : 0;
            $u_chmod      = $u_chmod        == 1 ? 1 : 0;
            $u_upload     = $u_upload       == 1 ? 1 : 0;
            $u_rename     = $u_rename       == 1 ? 1 : 0;
            $u_edit       = $u_edit         == 1 ? 1 : 0;
            $u_delete     = $u_delete       == 1 ? 1 : 0;
            $u_copy       = $u_copy         == 1 ? 1 : 0;
            $u_move       = $u_move         == 1 ? 1 : 0;
            $u_mkdir      = $u_mkdir        == 1 ? 1 : 0;
            $u_mkfile     = $u_mkfile       == 1 ? 1 : 0;
            $u_overwrite  = $u_overwrite    == 1 ? 1 : 0;
            $u_zip        = $u_zip          == 1 ? 1 : 0;
            $u_mysql      = $u_mysql        == 1 ? 1 : 0;

            if (!ereg("[" . $safe . "]$", $u_rootdir))
            {
                // There was no trailing slash so add it
                $rootdir = $rootdir . $slash;
            }
            $u_rooturl = ereg_replace("/$", "", $u_rooturl); // Remove any trailing slash for the URL

            // Hash the password
            if ($u_password == "")
            {
                $u_password   = $params["password"];
            }
            else
            {
                $u_password = md5($u_password);
            }

            // Create the file data 
            $userlist = file($script_dir . "/settings/" . $scripts["userlist"]);
            $fdata = "";

            while(list(,$value) = each($userlist))
            {
                if ($value != "")
                {
                    list($username, $password, $htpasswd, $changepass, $chmod, $upload, $rename, $edit, $delete, $copy, $move, $newfolder, $newfile, $overwrite, $compress, $mysql, $dbhost, $dbuser, $dbpass, $dbname, $root_url, $root_dir, $max_space, $lang) = split("[|]", $value);

                    $lang = trim($lang);

                    if ($username == $u_username)
                    {
                        $fdata .= "$u_username|$u_password|$u_lock|$u_chpass|$u_chmod|$u_upload|$u_rename|$u_edit|$u_delete|$u_copy|$u_move|$u_mkdir|$u_mkfile|$u_overwrite|$u_zip|$u_mysql|$u_dbserver|$u_dbuser|$u_dbpass|$u_dbs|$u_rooturl|$u_rootdir|$u_space|$u_lang\r\n";
                    }
                    else
                    {
                        $fdata .= "$username|$password|$htpasswd|$changepass|$chmod|$upload|$rename|$edit|$delete|$copy|$move|$newfolder|$newfile|$overwrite|$compress|$mysql|$dbhost|$dbuser|$dbpass|$dbname|$root_url|$root_dir|$max_space|$lang\r\n";
                    }
                }
            }

            // Set a default message
            $data = msg("There was an unknown error updating the user's account. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . $scripts["userlist"] . "&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");

            if(($fp = fopen($script_dir . "/settings/" . $scripts["userlist"], "w")) == TRUE)
            {
                // The file was opened, now to lock it
                if ($flock == TRUE)
                {
                    flock($fp, LOCK_EX);
                }
        
                $fdata = clean_crlf($fdata);

                // The file was opened and locked so write the data
                fwrite($fp, $fdata);
                if ($flock == TRUE)
                {
                    flock($fp, LOCK_UN); // Unlock
                }
  		        fclose($fp);

                $copy = "";
                if ($u_rootdir != $params["root"])
                {
                    if ((file_exists($u_rootdir) == TRUE && unlink($u_rootdir) == TRUE) || file_exists($u_rootdir) == FALSE)
                    {
                        $copy = rename($params["root"], $u_rootdir) == TRUE ? "<br />The users directory stucture has been copied to their new root directory" : "<br />The users existing directory structure could not be copied, you should do this manually";
                    }
                    else
                    {
                        $copy = "<br />The users existing directory structure could not be copied, you should do this manually";
                    }
                }

                $data = msg("The user's account has been updated" . $copy, "User Account Updated");
            }
        }
    }
}
else if ($op == "add")
{
    // Build the language drop down list
    $langauges[0] = "System Default";
    foreach ($lang_name as $key => $var)
    {
        $langauges[$key] = $var;
    }
    $lang_list = dropdown($langauges, 0);

    $pagetitle = "Add a New User";

    $form  = "	    <form action=\"$PHP_SELF\" method=\"post\">\r\n";
    $form .= "		<input type=\"hidden\" name=\"op\" value=\"insert\" />\r\n";
    $form .= "			<table border=\"0\" width=\"100%\" cellpadding=\"3\">\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"center\" colspan=\"2\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Please enter the users details below</font></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Access Details</i></font></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Username</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"username\" style=\"width: 90%\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Password</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"password\" style=\"width: 90%\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Retype Password</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"password\" name=\"password2\" style=\"width: 90%\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "					<td align=\"center\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\"></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>User Permissions</i><br /><br />The user can....</font></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>&quot;Lock&quot; a directory?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" id=\"lock\" name=\"lock\" checked=\"checked\" value=\"1\" /> <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Apache Only</font></td>\r\n";
    $form .= "		        </tr>\r\n";
    $form .= "			    <tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Change their own password?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"chpass\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>CHMOD files or folders?</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"chmod\" checked=\"checked\" value=\"1\" /> <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Unix based systems only</font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Upload files?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"upload\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Rename existing files or folders?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"rename\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Edit existing files?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"edit\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "			    </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Delete existing files or folders?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"delete\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "		        </tr>\r\n";
    $form .= "			    <tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Use &quot;Copy To&quot;?</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"copy\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Use &quot;Move To&quot;?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"move\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create new folders?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"mkdir\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create new files?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"mkfile\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Overwrite existing files?</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"overwrite\" checked=\"checked\" value=\"1\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Create Zip archives?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"zip\" checked=\"checked\" value=\"1\" /> <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Zlib extension required</font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr align=\"center\">\r\n";
    $form .= "				    <td colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\" align=\"center\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>MySQL Settings</i></font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Allow access to MySQL?</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"checkbox\" name=\"mysql\" value=\"1\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Server</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbserver\" style=\"width: 90%\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Username</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbuser\" style=\"width: 90%\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Database Password</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbpass\" style=\"width: 90%\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Databases</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"dbs\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Comma seperated list of databases</font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "					<td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><hr width=\"85%\" align=\"center\" /></td>\r\n";
    $form .= "				</tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" colspan=\"2\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><i>Other Settings</i></font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"> <font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Root Directory</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"rootdir\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">Trailing slash required</font></td>\r\n";
    $form .= "			    </tr>\r\n";
    $form .= "				<tr>\r\n";
    $form .= "					<td align=\"left\" valign=\"top\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Root URL</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><input type=\"text\" name=\"rooturl\" style=\"width: 90%\" /><br /><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">No trailing slash required</font></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Space Limit</b></font></td>\r\n";
    $form .= "					<td align=\"left\" width=\"85%\"><input type=\"text\" name=\"space\" size=\"10\" /> <select name=\"type\"><option value=\"4\">Gigabytes</option><option value=\"3\" selected=\"selected\">Megabytes</option><option value=\"2\">Kilobytes</option><option value=\"1\">Bytes</option></select></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "		        <tr>\r\n";
    $form .= "				    <td align=\"left\" width=\"15%\" nowrap=\"nowrap\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\"><b>Default Language</b></font></td>\r\n";
    $form .= "		            <td align=\"left\" width=\"85%\"><select name=\"lang\">" . $lang_list .  "</select></td>\r\n";
    $form .= "			    </tr>\r\n";
    $form .= "				<tr> \r\n";
    $form .= "					<td align=\"center\" colspan=\"2\"><input type=\"submit\" value=\"Create Account\" /></td>\r\n";
    $form .= "	            </tr>\r\n";
    $form .= "			</table>\r\n";
    $form .= "		    </form>\r\n";

    $data = msg($form, $pagetitle);
}
else if ($op == "insert")
{    
    // Get the Access details
    $username   = trim(param("username", "POST", 1));
    $password   = trim(param("password", "POST", 1));
    $password2  = trim(param("password2", "POST", 1));

    // Get the Permissions
    $lock       = param("lock", "POST");
    $chpass     = param("chpass", "POST");
    $chmod      = param("chmod", "POST");
    $upload     = param("upload", "POST");
    $rename     = param("rename", "POST");
    $edit       = param("edit", "POST");
    $delete     = param("delete", "POST");
    $copy       = param("copy", "POST");
    $move       = param("move", "POST");
    $mkdir      = param("mkdir", "POST");
    $mkfile     = param("mkfile", "POST");
    $overwrite  = param("overwrite", "POST");
    $zip        = param("zip", "POST");

    // Get the MySQL details
    $mysql      = param("mysql", "POST");
    $dbserver   = param("dbserver", "POST", 1);
    $dbuser     = param("dbuser", "POST", 1);
    $dbpass     = param("dbpass", "POST", 1);
    $dbs        = param("dbs", "POST", 1);

    // Ensure there are no spaces or trailing ,
    $db = explode(",", $dbs);
    $dbs = "";
    foreach($db as $var)
    {
        $dbs .= trim($var) . ",";
    }
    $dbs = preg_replace("/,+$/", "", $dbs);

    // Get the other settings
    $rootdir    = trim(param("rootdir", "POST", 1));
    $rooturl    = trim(param("rooturl", "POST", 1));
    $space      = trim(param("space", "POST", 1));
    $type       = param("type", "POST");
    $lang       = param("lang", "POST");

    $pagetitle = "Add a New User";

    if (empty($username))
    {
        // A required field is missing
        $data = msg("A required field from the &quot;<i>Access Details</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and fill in the missing fields</a>");
    }
    if ((empty($password2) || empty($password2)) && $username != "guest")
    {
        // A required field is missing
        $data = msg("A required field from the &quot;<i>Access Details</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and fill in the missing fields</a>");
    }
    else if (strlen($password) < 5 && $username != "guest")
    {
        // The password is too short
        $data = msg("Sorry but the password must be at least 5 characters long<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if ($password != $password2 && $username != "guest")
    {
        // The passwords do not match
        $data = msg("Sorry but the passwords you entered do not match<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (find_user($username) != FALSE)
    {
        // The user already exists
        $data = msg("Sorry but a user of that name already exists<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and enter a new username</a>");
    }
    else if ($mysql == 1 && (empty($dbserver) || empty($dbuser) || empty($dbpass) || empty($dbs)))
    {
        // The admin has given the user MySQL access but didn't enter any details
        $data = msg("You have selected to allow the user to access MySQL but you have not entered their &quot;<i>MySQL Settings</i>&quot;<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and correct this</a>");
    }
    else if (empty($rootdir) || empty($rooturl) || empty($space))
    {
        // A required field is missing
        $data = msg("A required field from the &quot;<i>Other Settings</i>&quot; section is missing<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Go back and fill in the missing fields</a>");
    }
    else
    {
        // All fields are valid, now insert the data

        // Set a default message
        $data = msg("There was an unknown error creating the new account. Ensure that &quot;" . $script_dir  . $slash . "settings" . $slash . $scripts["userlist"] . "&quot; is writable<br /><br /><a href=\"javascript:history.go(-1);\">&laquo; Try again</a>", "System Error");

        if(($fp = fopen($script_dir . "/settings/" . $scripts["userlist"], "a")) == TRUE)
        {
            // Work out the maximum space in bytes
            if ($type == 2)
            {
                $type = 1024;
            }
            else if ($type == 3)
            {
                $type = 1048576;
            }
            else if ($type == 4)
            {
                $type = 1073741824;
            }
            else
            {
                $type = 1;
            }
            $space = (int) $space * $type;

            // Work out the actual values
            $lock       = $lock         == 1 ? 1 : 0;
            $chpass     = $chpass       == 1 ? 1 : 0;
            $chmod      = $chmod        == 1 ? 1 : 0;
            $upload     = $upload       == 1 ? 1 : 0;
            $rename     = $rename       == 1 ? 1 : 0;
            $edit       = $edit         == 1 ? 1 : 0;
            $delete     = $delete       == 1 ? 1 : 0;
            $copy       = $copy         == 1 ? 1 : 0;
            $move       = $move         == 1 ? 1 : 0;
            $mkdir      = $mkdir        == 1 ? 1 : 0;
            $mkfile     = $mkfile       == 1 ? 1 : 0;
            $overwrite  = $overwrite    == 1 ? 1 : 0;
            $zip        = $zip          == 1 ? 1 : 0;
            $mysql      = $mysql        == 1 ? 1 : 0;

            if (!ereg("[" . $safe . "]$", $rootdir))
            {
                // There was no trailing slash so add it
                $rootdir = $rootdir . $slash;
            }
            $rooturl = ereg_replace("/$", "", $rooturl); // Remove any trailing slash for the URL

            // Create the file data
            $fdata = "$username|" . md5($password) . "|$lock|$chpass|$chmod|$upload|$rename|$edit|$delete|$copy|$move|$mkdir|$mkfile|$overwrite|$zip|$mysql|$dbserver|$dbuser|$dbpass|$dbs|$rooturl|$rootdir|$space|$lang\r\n";

            // The file was opened, now to lock it
            if ($flock == TRUE)
            {
                flock($fp, LOCK_EX);
            }
        
            $fdata = clean_crlf($fdata);

            // The file was opened and locked so write the data
            fwrite($fp, $fdata);
            if ($flock == TRUE)
            {
                flock($fp, LOCK_UN); // Unlock
            }
  		    fclose($fp);

            if (file_exists($rootdir) == FALSE)
            {
                $madedir = mkdir($rootdir, 0777) == TRUE ? "<br />The new users directory was also created as it did not exist" : "<br />The new users directory (&quot;" . $rootdir . "&quot;) could not be created, you should create it yourself and CHMOD it to 777";
            }

            $data = msg("The new user has been created successfully" . $madedir, "User Account Created");
        }
    }
}
else
{
    redirect("admin/index.php?p=main");
}

// Output the page
$endtime = endtime($starttime);
$page = array("IMGS" => $imgs, "END" => $end, "VERSION" => $version, "TITLE" => $pagetitle, "CONTENT" => trim($data), "STATS" => "This page took $endtime seconds to produce", "charset" => $charset);
echo template($page, $script_dir . "/settings/templates/admin.tpl");

?>