<?php

/*
 * Invision Power File Manager
 * Server Space Image Script
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 22nd February 2003 
 *
 */

error_reporting(0);

include("../settings/settings.inc.php");

function param($name)
{
    return isset($_GET) ? $_GET[$name] : $GLOBALS["HTTP_GET_VARS"][$name];
}

header("Content-type:image/png");

$id         = ImageCreate(180, 180);
$hcenter    = ImageSX($id)/2;
$vcenter    = ImageSY($id)/2;

$diameter   = 160;

// Define the colours
$black          = ImageColorAllocate($id, 0, 0, 0);
$white          = ImageColorAllocate($id, 255, 255, 255);

$pie_color[1]   = ImageColorAllocate($id, $free_colour[0], $free_colour[1], $free_colour[2]);   // Free Space
$pie_color[2]   = ImageColorAllocate($id, $used_colour[0], $used_colour[1], $used_colour[2]);   // Used Space

// The white back ground will be transparent
ImageFill($id, 0, 0, $white);
ImageColorTransparent($id, $white);

$total  = param("free") + param("used");
$n      = 0;

// Read the arguments into different arrays
$value[1] = param("free");
$value[2] = param("used");

$arc_rad[1] = $value[1] * 2 * pi(NULL);
$arc_rad[2] = $total * 2 * pi(NULL);
$arc_dec[1] = $value[1] * 360;
$arc_dec[2] = $total * 360;

// The base
$arc_rad[0] = 0;
$arc_dec[0] = 0;

// Count the labels
for($i=1; $i<=2; $i++)
{
    $idf = 1;
    $hfw = ImageFontWidth($idf);
    $vfw = ImageFontHeight($idf);

    // Calculate the percents
    $perc[$i]    = $value[$i]/$total;
    $percstr[$i] = (string) number_format($perc[$i] * 100, 1) . "%";

    // Calculate the arc and line positions
    $arc_rad[$i]    = $arc_rad[$i]/$total;
    $arc_dec[$i]    = $arc_dec[$i]/$total;
    $hpos           = round($hcenter + ($diameter/2) * Sin($arc_rad[$i]));
    $vpos           = round($vcenter + ($diameter/2) * Cos($arc_rad[$i]));
    ImageLine($id, $hcenter, $vcenter, $hpos, $vpos, $black);
    ImageArc($id, $hcenter, $vcenter, $diameter, $diameter, $arc_dec[$i-1], $arc_dec[$i], $black);
}


for($i=1; $i<=2; $i++)
{
    $arc_rad_label  = $arc_rad[$i-1] + 0.5 * $perc[$i] * 2 * pi(NULL);
    $hpos           = $hcenter + 0.8 * ($diameter/2) * Sin($arc_rad_label);
    $vpos           = $vcenter + 0.8 * ($diameter/2) * Cos($arc_rad_label);
    ImageFillToBorder($id, $hpos, $vpos, $black, $pie_color[$i]);
}

ImagePng($id);
ImageDestroy($id);

?>