<?php

/*
 * Invision Power File Manager
 * Admin Code Library
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 17th March 2003 
 *
 */

// Check the user is autherised to access the control panel
function auth()
{
    global $cookie_admin, $adminpass;

    if (param($cookie_admin, "COOKIE") != $adminpass)
    {
        // The username in the cookie is not the admin password
        redirect("admin/login.php");
    }

    return true;
}

// Return a formatted message
function msg($msg, $title = "User Error")
{
    // Format the message and return it
    $data = "<table border=\"0\" width=\"85%\" bgcolor=\"#000000\" cellpadding=\"4\" cellspacing=\"1\">\r\n";
    $data .= "	  <tr>\r\n";
    $data .= "        <th align=\"left\" bgcolor=\"#4682B4\" valign=\"middle\"><font size=\"2\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#FFFFFF\">" . $title . "</font></th>\r\n";
    $data .= "	  </tr>\r\n";
    $data .= "	  <tr>\r\n";
    $data .= "        <td align=\"left\" bgcolor=\"#F5F5F5\" valign=\"middle\"><font size=\"1\" face=\"Verdana, Geneva, Arial, Helvetica, Sans-Serif\" color=\"#000000\">" . $msg . "</font></td>\r\n";
    $data .= "	  </tr>\r\n";
    $data .= "</table>\r\n";

    return $data;
}

// Find the user
function find_user($user)
{
    global $scripts, $script_dir;

    $found = FALSE;
    $usercheck = file($script_dir . "/settings/" . $scripts["userlist"]);

    while(list(,$value) = each($usercheck))
    {
        list($username, $password, $htpasswd, $changepass, $chmod, $upload, $rename, $edit, $delete, $copy, $move, $newfolder, $newfile, $overwrite, $compress, $mysql, $dbhost, $dbuser, $dbpass, $dbname, $root_url, $root_dir, $max_space, $lang) = split("[|]", $value);

        if ($username == $user)
        {
            $params["name"]      = trim($username);
            $params["password"]  = trim($password);
            $params["htpasswd"]  = trim($htpasswd);
            $params["change"]    = trim($changepass);
            $params["CHMOD"]     = trim($chmod);
            $params["upload"]    = trim($upload);
            $params["rename"]    = trim($rename);
            $params["edit"]      = trim($edit);
            $params["delete"]    = trim($delete);
            $params["copy"]      = trim($copy);
            $params["move"]      = trim($move);
            $params["newfolder"] = trim($newfolder);
            $params["newfile"]   = trim($newfile);
            $params["overwrite"] = trim($overwrite);
            $params["compress"]  = trim($compress);
            $params["mysql"]     = trim($mysql);
            $params["dbhost"]    = trim($dbhost);
            $params["dbuser"]    = trim($dbuser);
            $params["dbpass"]    = trim($dbpass);
            $params["dbname"]    = trim($dbname);
            $params["root"]      = trim($root_dir);
            $params["root_url"]  = trim($root_url);
            $params["space"]     = trim($max_space);
            $params["lang"]      = trim($lang);
        }
    }

    return $params;
}

// Create a checkbox with the correct value
function checkbox($name, $value)
{
    if ($value == 1)
    {
        return "<input type=\"checkbox\" name=\"" . $name . "\" value=\"1\" checked=\"checked\" />";
    }
    else
    {
        return "<input type=\"checkbox\" name=\"" . $name . "\" value=\"1\" />";
    }
}

// Builds the drop down list for the users size limit, selecting a suitible size format
function space_dropdown($space)
{
    $selected = 1; // Default item (Bytes)

    if ($space >= 1073741824)
    {
        // Gigabytes
        $space = round($space / 1073741824 * 100) / 100;
        $selected = 4;
    }
    else if ($space >= 1048576)
    {
        // Megabytes
        $space = round($space / 1048576 * 100) / 100;
        $selected = 3;
    }
    else if ($space >= 1024)
    {
        // Kilobytes
        $space = round($space / 1024 * 100) / 100;
        $selected = 2;
    }

    // The array of menu items
    $data = array("4" => "Gigabytes", "3" => "Megabytes", "2" => "Kilobytes", "1" => "Bytes");

    // Return the finished fields
    return "<input type=\"text\" value=\"" . $space . "\" name=\"space\" size=\"10\" /> <select name=\"type\">" . dropdown($data, $selected) . "</select>";

}

// A function to update the configuration file, including handling the arrays
function update_config($data, $type)
{
    // Possible types
    // 1 - Settings
    // 2 - File Icons
    // 3 - ASCII Files
    // 4 - File Names
    // 5 - Visual Settings
    // 6 - License

    // Define all settings values as global
    global $script_dir, $script_url, $cookie_admin, $cookie_user, $cookie_pass, $cookie_lang, $cookie_temp, $cookie_time, $default_lang, $debug, $flock, $format, $hide, $hide_dot, $adminpass, $icons , $ascii, $scripts, $used_colour, $free_colour, $upload_limit, $license, $no_ext, $edit_lock, $use_gzip, $http_headers, $anon_access, $note, $timeout, $new_chmod;

    // Begin building up the data
    $fdata = "<?php\r\n\r\n";
    $fdata .= "/*\r\n";
    $fdata .= " * Invision Power File Manager v1\r\n";
    $fdata .= " * Global Configuration Script\r\n";
    $fdata .= " * Copyright (c) 2003 Invision Power Services\r\n";
    $fdata .= " * -------------------------------------\r\n";
    $fdata .= " * You may not remove the copyright or\r\n";
    $fdata .= " * redistribute the script in any form\r\n";
    $fdata .= " *\r\n";
    $fdata .= " * Authors: Stephen Ball <stephen@invisionfilemanager.com>\r\n";
    $fdata .= " *\r\n";
    $fdata .= " */\r\n\r\n";

    // Build the script settings
    $fdata .= "// Misc Settings\r\n";
    if ($type == 1)
    {
        // Set the TRUE or FALSE string values
        $data["hide_dot"]     = $data["hide_dot"]     == 1 ? 'TRUE' : 'FALSE';
        $data["debug"]        = $data["debug"]        == 1 ? 'TRUE' : 'FALSE';
        $data["flock"]        = $data["flock"]        == 1 ? 'TRUE' : 'FALSE';
        $data["no_ext"]       = $data["no_ext"]       == 1 ? 'TRUE' : 'FALSE';
        $data["edit_lock"]    = $data["edit_lock"]    == 1 ? 'TRUE' : 'FALSE';
        $data["use_gzip"]     = $data["use_gzip"]     == 1 ? 'TRUE' : 'FALSE';
        $data["http_headers"] = $data["http_headers"] == 1 ? 'TRUE' : 'FALSE';
        $data["anon_access"]  = $data["anon_access"]  == 1 ? 'TRUE' : 'FALSE';
        $data["timeout"]      = $data["timeout"]      == 0 ? 'NULL' : $data["timeout"];
        $data["cookie_time"]  = $data["cookie_time"]  == 0 ? 'NULL' : $data["cookie_time"];

        $data["format"]     = ereg_replace("\{(.*)\}", "{\A\\\T}", $data["format"]);

        $data["script_dir"] = str_replace("\\t", "/t", $data["script_dir"]);
        $data["script_dir"] = str_replace("\\r", "/r", $data["script_dir"]);
        $data["script_dir"] = str_replace("\\n", "/n", $data["script_dir"]);

        // Use the new script settings
        $fdata .= "\$script_dir      = \"" . $data["script_dir"] . "\"; // The directory the script is in\r\n";
        $fdata .= "\$script_url      = \"" . $data["script_url"] . "\"; // The URL to the script\r\n";
        $fdata .= "\$cookie_admin    = \"" . $data["cookie_admin"] . "\"; // The name of the admin cookie\r\n";
        $fdata .= "\$cookie_user     = \"" . $data["cookie_user"] . "\"; // The name for the username cookie\r\n";
        $fdata .= "\$cookie_pass     = \"" . $data["cookie_pass"] . "\"; // The name for the password cookie\r\n";
        $fdata .= "\$cookie_lang     = \"" . $data["cookie_lang"] . "\"; // The name for the language cookie\r\n";
        $fdata .= "\$cookie_temp     = \"" . $data["cookie_temp"] . "\"; // The name for the temporary htpasswd cookie\r\n";
        $fdata .= "\$cookie_time     = " . $data["cookie_time"] . "; // The length of time to store the cookies (leave blank for deletion upon browser closure)\r\n";
        $fdata .= "\$default_lang    = " . $data["default_lang"] . "; // The default language to use\r\n";
        $fdata .= "\$debug           = " . $data["debug"] . "; // Enable Debug mode (to report errors)\r\n";
        $fdata .= "\$format          = \"" . $data["format"] . "\"; // The format to use for the file dates\r\n";
        $fdata .= "\$hide            = \"" . $data["hide"] . "\"; // The name of the file used to prevent directory access\r\n";
        $fdata .= "\$note            = \"" . $data["note"] . "\"; // The name of the file used for directory notes\r\n";
        $fdata .= "\$hide_dot        = " . $data["hide_dot"] . "; // Hide files beginning with a . dot\r\n";
        $fdata .= "\$flock           = " . $data["flock"] . "; // Flock files\r\n";
        $fdata .= "\$upload_limit    = " . $data["upload_limit"] . "; // Number of file browsers to show on multi file upload page\r\n";
        $fdata .= "\$no_ext			 = " . $data["no_ext"] . "; // Display edit for files with no extension\r\n";
        $fdata .= "\$edit_lock		 = " . $data["edit_lock"] . "; // Lock files which are being edited\r\n";
        $fdata .= "\$timeout         = " . $data["timeout"] . "; // Number of seconds to keep files locked for\r\n";
        $fdata .= "\$use_gzip		 = " . $data["use_gzip"] . "; // USE GZIP compression\r\n";
        $fdata .= "\$http_headers	 = " . $data["http_headers"] . "; // Output HTTP headers\r\n";
        $fdata .= "\$anon_access     = " . $data["anon_access"] . "; // Anonymous access\r\n";
        $fdata .= "\$new_chmod       = \"" . $data["new_chmod"] . "\"; // CHMOD value for new files\r\n";
        $fdata .= "\$adminpass       = \"" . $data["adminpass"] . "\"; // The admin password\r\n\r\n";
    }
    else
    {
        // Set the TRUE or FALSE string values
        $hide_value     = $hide_dot     == 1 ? 'TRUE' : 'FALSE';
        $debug_value    = $debug        == 1 ? 'TRUE' : 'FALSE';
        $flock_value    = $flock        == 1 ? 'TRUE' : 'FALSE';
        $ext_value      = $no_ext       == 1 ? 'TRUE' : 'FALSE';
		$lock_value	    = $edit_lock    == 1 ? 'TRUE' : 'FALSE';
        $gzip_value     = $use_gzip     == 1 ? 'TRUE' : 'FALSE';
		$http_value	    = $http_headers == 1 ? 'TRUE' : 'FALSE';
        $anon_value	    = $anon_access  == 1 ? 'TRUE' : 'FALSE';
        $timeout        = $timeout      == 0 ? 'NULL' : $timeout;
        $cookie_time    = $cookie_time  == 0 ? 'NULL' : $cookie_time;

        $format_value   = ereg_replace("\{(.*)\}", "{\A\\\T}", $format);

        $script_dir = str_replace("\\t", "/t", $script_dir);
        $script_dir = str_replace("\\r", "/r", $script_dir);
        $script_dir = str_replace("\\n", "/n", $script_dir);

        // Use the existing script settings
        $fdata .= "\$script_dir      = \"" . $script_dir . "\"; // The directory the script is in\r\n";
        $fdata .= "\$script_url      = \"" . $script_url . "\"; // The URL to the script\r\n";
        $fdata .= "\$cookie_admin    = \"" . $cookie_admin . "\"; // The name of the admin cookie\r\n";
        $fdata .= "\$cookie_user     = \"" . $cookie_user . "\"; // The name for the username cookie\r\n";
        $fdata .= "\$cookie_pass     = \"" . $cookie_pass . "\"; // The name for the password cookie\r\n";
        $fdata .= "\$cookie_lang     = \"" . $cookie_lang . "\"; // The name for the language cookie\r\n";
        $fdata .= "\$cookie_temp     = \"" . $cookie_temp . "\"; // The name for the temporary htpasswd cookie\r\n";
        $fdata .= "\$cookie_time     = " . $cookie_time . "; // The length of time to store the cookies (leave blank for deletion upon browser closure)\r\n";
        $fdata .= "\$default_lang    = " . $default_lang . "; // The default language to use\r\n";
        $fdata .= "\$debug           = " . $debug_value . "; // Enable Debug mode (to report errors)\r\n";
        $fdata .= "\$format          = \"" . $format_value . "\"; // The format to use for the file dates\r\n";
        $fdata .= "\$hide            = \"" . $hide . "\"; // The name of the file used to prevent directory access\r\n";
        $fdata .= "\$note            = \"" . $note . "\"; // The name of the file used for directory notes\r\n";
        $fdata .= "\$hide_dot        = " . $hide_value . "; // Hide files beginning with a . dot\r\n";
        $fdata .= "\$flock           = " . $flock_value . "; // Flock files\r\n";
        $fdata .= "\$upload_limit    = " . $upload_limit . "; // Number of file browsers to show on multi file upload page\r\n";
        $fdata .= "\$no_ext			 = " . $ext_value . "; // Display edit for files with no extension\r\n";
        $fdata .= "\$edit_lock		 = " . $lock_value . "; // Lock files which are being edited\r\n";
        $fdata .= "\$timeout         = " . $timeout . "; // Number of seconds to keep files locked for\r\n";
        $fdata .= "\$use_gzip		 = " . $gzip_value . "; // USE GZIP compression\r\n";
        $fdata .= "\$http_headers	 = " . $http_value . "; // Output HTTP headers\r\n";
        $fdata .= "\$anon_access     = " . $anon_value . "; // Anonymous access\r\n";
        $fdata .= "\$new_chmod       = \"" . $new_chmod . "\"; // CHMOD value for new files\r\n";
        $fdata .= "\$adminpass       = \"" . $adminpass . "\"; // The admin password\r\n\r\n";
    }

    // Build the file icons
    $fdata .= "// The file extensions and images to use for the icons\r\n";
    if ($type == 2)
    {
        // Use the new File Associations
        $str = "\$icons = array(\r\n";
        foreach ($data["image"] as $key => $var)
        {
            if ($data["image"][$key] != "" && $data["types"][$key] != "" && $data["delete"][$key] != 1)
            {
                // The image has a name, and some extensions, and isn't marked for deletion
                $str .= "    \"$var\" => \"" . $data["types"][$key] . "\",\r\n";
            }
        }
        $str .= ");\r\n\r\n";
        $str = ereg_replace(",\r\n);", "\r\n);", $str);

        $fdata .= $str;
    }
    else
    {
        // Use the existing File Associations
        $str = "\$icons = array(\r\n";
        foreach ($icons as $key => $var)
        {
            $str .= "    \"$key\" => \"" . $var . "\",\r\n";
        }
        $str .= ");\r\n\r\n";
        $str = ereg_replace(",\r\n);", "\r\n);", $str);

        $fdata .= $str;
    }

    // Build the ASCII list
    $fdata .= "// An array of extensions to ASCII files so that the script knows what can be edited\r\n";
    if ($type == 3)
    {
        $list = explode(" ", $data);

        // Use the new ASCII list
        $string = "";
        foreach($list as $var)
        {
            $string .= "\"$var\", ";
        }
        $string = ereg_replace(", $", "", $string);

        $fdata .= "\$ascii = array($string);\r\n\r\n";
    }
    else
    {
        // Use the existing ASCII list
        $string = "";
        foreach($ascii as $var)
        {
            $string .= "\"$var\", ";
        }
        $string = ereg_replace(", $", "", $string);

        $fdata .= "\$ascii = array($string);\r\n\r\n";
    }

    // Build the files names list
    $fdata .= "// An array of the script names (so that the scripts can be renamed)\r\n";
    if ($type == 4)
    {
        // Use the new file names
        $fdata .= "\$scripts[\"login\"]    = \"" . $data["login"] . "\";\r\n";
        $fdata .= "\$scripts[\"main\"]     = \"" . $data["main"] . "\";\r\n";
        $fdata .= "\$scripts[\"edit\"]     = \"" . $data["edit"] . "\";\r\n";
        $fdata .= "\$scripts[\"source\"]   = \"" . $data["source"] . "\";\r\n";
        $fdata .= "\$scripts[\"space\"]    = \"" . $data["space"] . "\";\r\n";
        $fdata .= "\$scripts[\"pass\"]     = \"" . $data["pass"] . "\";\r\n";
        $fdata .= "\$scripts[\"sql\"]      = \"" . $data["sql"] . "\";\r\n";
        $fdata .= "\$scripts[\"chmod\"]    = \"" . $data["chmod"] . "\";\r\n";
        $fdata .= "\$scripts[\"move\"]     = \"" . $data["move"] . "\";\r\n";
        $fdata .= "\$scripts[\"lock\"]     = \"" . $data["lock"] . "\";\r\n";
        $fdata .= "\$scripts[\"upload\"]   = \"" . $data["upload"] . "\";\r\n";
        $fdata .= "\$scripts[\"userlist\"] = \"" . $data["userlist"] . "\";\r\n\r\n";
    }
    else
    {
        // Use the existing file names
        $fdata .= "\$scripts[\"login\"]    = \"" . $scripts["login"] . "\";\r\n";
        $fdata .= "\$scripts[\"main\"]     = \"" . $scripts["main"] . "\";\r\n";
        $fdata .= "\$scripts[\"edit\"]     = \"" . $scripts["edit"] . "\";\r\n";
        $fdata .= "\$scripts[\"source\"]   = \"" . $scripts["source"] . "\";\r\n";
        $fdata .= "\$scripts[\"space\"]    = \"" . $scripts["space"] . "\";\r\n";
        $fdata .= "\$scripts[\"pass\"]     = \"" . $scripts["pass"] . "\";\r\n";
        $fdata .= "\$scripts[\"sql\"]      = \"" . $scripts["sql"] . "\";\r\n";
        $fdata .= "\$scripts[\"chmod\"]    = \"" . $scripts["chmod"] . "\";\r\n";
        $fdata .= "\$scripts[\"move\"]     = \"" . $scripts["move"] . "\";\r\n";
        $fdata .= "\$scripts[\"lock\"]     = \"" . $scripts["lock"] . "\";\r\n";
        $fdata .= "\$scripts[\"upload\"]   = \"" . $scripts["upload"] . "\";\r\n";
        $fdata .= "\$scripts[\"userlist\"] = \"" . $scripts["userlist"] . "\";\r\n\r\n";
    }

    // Build the name names list
    $fdata .= "// The scripts visual settings\r\n";
    if ($type == 5)
    {
        // Build the colour arrays
        $used_array = "";
        foreach ($data["used"] as $key => $var)
        {
            $used_array .= "\"" . $data["used"][$key] . "\", ";

        }
        $used_array = ereg_replace(", $", "", $used_array);

        $free_array = "";
        foreach ($data["free"] as $key => $var)
        {
            $free_array .= "\"" . $data["free"][$key] . "\", ";

        }
        $free_array = ereg_replace(", $", "", $free_array);

        // Use the new values
        $fdata .= "\$free_colour    = array(" . $free_array . "); // The colours to use for the free space on the pie chart\r\n";
        $fdata .= "\$used_colour    = array(" . $used_array . "); // The colours to use for the used space on the pie chart\r\n\r\n";
    }
    else
    {
        // Build the colour arrays
        $used_array = "";
        foreach ($used_colour as $key => $var)
        {
            $used_array .= "\"" . $used_colour[$key] . "\", ";

        }
        $used_array = ereg_replace(", $", "", $used_array);

        $free_array = "";
        foreach ($free_colour as $key => $var)
        {
            $free_array .= "\"" . $free_colour[$key] . "\", ";

        }
        $free_array = ereg_replace(", $", "", $free_array);

        // Use the existing values
        $fdata .= "\$free_colour    = array(" . $free_array . "); // The colours to use for the free space on the pie chart\r\n";
        $fdata .= "\$used_colour    = array(" . $used_array . "); // The colours to use for the used space on the pie chart\r\n\r\n";
    }

    // Toggle the license
    if ($type == 6)
    {
        $license = $license == 1 ? 0 : 1;
    }

    $fdata .= "\$license        = " . $license . "; // The license status\r\n\r\n";
    $fdata .= "?" . ">";

    if (($fp = fopen("../settings/settings.inc.php", "w")) == FALSE)
    {
        // The settings file could not be opened, return false
        return false;
    }
    else
    {
        $fdata = clean_crlf($fdata);

        // The file was opened, now to lock it
        if ($flock == TRUE)
        {
            flock($fp, LOCK_EX);
        }

        // The file was opened and locked so write the data
        fwrite($fp, $fdata);
        if ($flock == TRUE)
        {
            flock($fp, LOCK_UN);
        }
        fclose($fp);

        // The settings file was updated, return true
        return true;
    }
}

// A function to rebuild the language pack
function rebuild_lang_pack($lang)
{
    global $script_dir, $flock, $charset;

    // A list of the differents sections which make up the language pack
    $sections = array("temp_description", "login", "misc", "area", "tools", "main", "legend", "javascript", "operate", "changepass", "space", "database", "source", "edit", "compress", "upload", "chmod", "move", "lock", "uploads");
    $comments = array("Text used for template descriptions", "Text used on the login page", "Misc text\r\n// Note the %s for the parse time and the %g for the gzip status", "Text used on the area buttons", "Text used on tool buttons", "Text used on the main page", "Text used for the legend", "Text used by JavaScript messages\r\n// DO NOT change the +  name +  part of the code otherwise the JS won't work, also leave the \\\\r\\\\n with double slashes", "Messages shown when the user performs an action", "Text for the change password page", "Text used on the server space page", "Text used on the SQL Manager page", "Text used on the Source highlighting page", "Text used on the file editor", "Text used on the archive log\r\n// %name refers to the file name, %date is the date and %size is the file size\r\n// %program is the program name and %version is the file version", "Messages used when there is an upload error", "Messages used on the CHMOD dialog", "Messages used on the lock dialog", "Messages used on the upload page\r\n// %i refers to the file number", "Messages used on the move dialog");

    $str = "<?php\r\n\r\n";
    $str .= "\$charset = \"" .  $charset . "\"; // The character set to use\r\n\r\n";

    // Go through and make each item global and then create the array
    foreach ($sections as $index => $item)
    {
        global ${$item};
        $str .= "// " . $comments[$index] . "\r\n";
        $str .= build_array(${$item}, $item) . "\r\n";
    }

    $str .= "?" . ">";

    if (($fp = fopen($script_dir . "/languages/" . $lang . ".lng.php", "w")) == FALSE)
    {
        return false;
    }
    else
    {
        // The file was opened, now to lock it
        if ($flock == TRUE)
        {
            flock($fp, LOCK_EX);
        }

        $str = clean_crlf($str);

        // The file was opened and locked so write the data
        fwrite($fp, $str);
        if ($flock == TRUE)
        {
            flock($fp, LOCK_UN);
        }

        fclose($fp);

        return true;
    }
}

// A function to build a string array
function build_array($array, $name)
{
    $str = "";

    foreach ($array as $key => $var)
    {
        // Fix the quotes in the "compress" section
        $var = str_replace("\"", "\\\"", $var);

        // Fix the quotes in the "javascript" section
        $var = str_replace("\\\\\"\\", "\\\\\\\"\\", $var); // Fix the " + name + " part
        $var = str_replace("\\\"\\\\", "\\\"\\\\\\", $var); // Fix the " + name + " part
        $var = str_replace("\\r\\n", "\\\\r\\\\n", $var);   // Fix the \\r\\n part
        $var = str_replace("\\\\\\'", "'", $var);
        $var = str_replace("\\\\\"%name\\\\\"", "\\\"%name\\\"", $var);

        if (is_string($key) == TRUE)
        {
            $str .= "\$" . $name . "[\"" . $key . "\"] = \"" . $var . "\";\r\n";
        }
        else
        {
            $str .= "\$" . $name . "[" . $key . "] = \"" . $var . "\";\r\n";
        }
    }

    return $str;
}

// A function to check is a string value is a valid RGB value
function is_rgb($array)
{
    foreach ($array as $var)
    {
        $var = (real) $var; // Set the value to an integer

        if (is_real($var) == false)
        {
            // The value is not a whole number, it is either a string or decimal
            return false;
        }
        else if ($var < 0 || $var > 255)
        {
            // The value is too high or too low
            return false;
        }
    }

    // All items have been checked so the values are valid
    return true;
}

// A pair of functions to convert an RGB value to a hex string
function RGBtoHex($red, $green, $blue)
{
    $a = HexValue(floor($red / 16));
    $b = HexValue($red % 16);
    $c = HexValue(floor($green / 16));
    $d = HexValue($green % 16);
    $e = HexValue(floor($blue / 16));
    $f = HexValue($blue % 16);

    return $a . $b . $c . $d . $e . $f;
}

function HexValue($dec)
{
    $hex = array("10" => "A", "11" => "B", "12" => "C", "13" => "D", "14" => "E", "15" => "F");

    foreach($hex as $key => $var)
    {
        if ($key == $dec)
        {
            return $var;
        }
    }
    return $dec;
}

// A function to convert none standard chars to entities, or back again
function entity_convert($str, $quotes = 1, $mode = 0)
{
    // Build the HTML entity array
    $chars = get_html_translation_table(HTML_ENTITIES); // Most items exist in the translation table
    $chars[chr(255)] = "&yuml;"; // y-umlaut is missing, so add it

    unset($chars[chr(160)]); // We don't want white space converted so unset the first item
    unset($chars["<"]);
    unset($chars[">"]);


    // If quotes is set to 0 we don't want to convert quotes, so remove it
    if ($quotes == 0)
    {
        unset($chars[chr(34)]);
    }

    // If the mode is set to 1 then we need to flip the array as the user is converting back
    if ($mode == 1)
    {
        $chars = array_flip($chars);
    }

    // Finally parse the string and return
    return strtr($str, $chars);
}

// Creates the menu listing
function menulink($id)
{
    global $show;
    
    $output = "";

    if (in_array($id, $show) == FALSE)
    {
        $output .= $id . ";";
    }
         
    foreach ($show as $var)
    {
        if ($var != $id && $var != "")
        {
            $output .= $var . ";";
        }
    }
    
    $output = str_replace("none;", "", $output);

    // No items are shown, so add none to the string
    if ($output == "")
    {
        $output = "none";
    }

    return $output;
}

?>