<?php

/*
 * Invision Power File Manager
 * Common Code Library
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 26th March 2003 
 *
 */

$version    = "1.0.1";
$copyright  = $license == 1 ? "" : "Powered by <a href=\"http://www.invisionfilemanager.com\" target=\"_blank\">Invision Power File Manager</a> v" . $version . " &copy; 2003 <a href=\"http://www.invisionpower.com\" target=\"_blank\">Invision PS, Inc</a>.";

// Checks that the user exists if so an array of all the users rights are returned, otherwise false is returned
function auth_user($user, $pass)
{
    global $scripts, $script_dir;

    $params = FALSE;
    $usercheck = file($script_dir . "/settings/" . $scripts["userlist"]);

    while(list(,$value) = each($usercheck))
    {
        list($username, $password, $htpasswd, $changepass, $chmod, $upload, $rename, $edit, $delete, $copy, $move, $newfolder, $newfile, $overwrite, $compress, $mysql, $dbhost, $dbuser, $dbpass, $dbname, $root_url, $root_dir, $max_space, $lang) = split("[|]", $value);

        if ($username == $user && $pass == $password)
        {
            $params["name"]      = trim($username);
            $params["password"]  = trim($password);
            $params["htpasswd"]  = trim($htpasswd);
            $params["change"]    = trim($changepass);
            $params["CHMOD"]     = trim($chmod);
            $params["upload"]    = trim($upload);
            $params["rename"]    = trim($rename);
            $params["edit"]      = trim($edit);
            $params["delete"]    = trim($delete);
            $params["copy"]      = trim($copy);
            $params["move"]      = trim($move);
            $params["newfolder"] = trim($newfolder);
            $params["newfile"]   = trim($newfile);
            $params["overwrite"] = trim($overwrite);
            $params["compress"]  = trim($compress);
            $params["mysql"]     = trim($mysql);
            $params["dbhost"]    = trim($dbhost);
            $params["dbuser"]    = trim($dbuser);
            $params["dbpass"]    = trim($dbpass);
            $params["dbname"]    = trim($dbname);
            $params["root"]      = trim($root_dir);
            $params["root_url"]  = trim($root_url);
            $params["space"]     = trim($max_space);
            $params["lang"]      = trim($lang);
        }
    }

    return $params;
}

// Returns the time that execution began
function starttime()
{
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $starttime = $mtime;

    return $starttime;
}

// Returns the time that execution ended
function endtime($starttime)
{
    $mtime = microtime();
    $mtime = explode(" ",$mtime);
    $mtime = $mtime[1] + $mtime[0];
    $endtime = $mtime;
    $totaltime = ($endtime - $starttime);

    $totaltime = round($totaltime, 3);

    return $totaltime;
}

// A function to display the directory listing
function traverse_dir($dir)
{
    global $main, $params, $format, $scripts, $safe, $hide_dot, $PHP_SELF, $slash, $ascii, $slash, $this_dir, $edit_lock, $note, $timeout;

    // Create variable to store files and directories
    $subdirs_array  = array();
    $files_array    = array();
    $subdirs        = array();
    $files          = array();
    $total          = 0;
    $up             = "";
    $this_dir       = $dir;

    // Change into the active directory
    chdir($dir);

    // Open the directory
    if (($handle = opendir($dir)) == FALSE)
    {
        if ($dir == $params["root"])
        {
            $info = array(
                "folders"       => "",
                "files"         => "",
                "current"       => "",
                "total_size"    => "",
                "columns"       => "",
                "msg"           => $main["no_root"],
                "fatal"         => 1,
                "up"            => "",
                "this_dir"      => "",
                "nav"           => "",
                "notes"         => ""
            );
            return $info;
        }
        else
        {
            $returned = traverse_dir($params["root"]);

            $info = array(
                "folders"       => $returned["folders"],
                "files"         => $returned["files"],
                "current"       => $returned["current"],
                "total_size"    => $returned["total_size"],
                "msg"           => $main["nodir"],
                "up"            => $returned["up"],
                "columns"       => $returned["columns"],
                "this_dir"      => $returned["this_dir"],
                "nav"           => $returned["nav"],
                "notes"         => $returned["notes"]
            );

            return $info;
        }
    }
    else
    {
        // If a note exists, read in the data
        if (file_exists($dir . $note) == TRUE)
        {
            $fp = fopen($dir . $note, "r");
            $notes = fread($fp, filesize($dir . $note));
            fclose($fp);
        }

        // Loop through all files and directories and
        // place them in their respective arrays.
        while($entry = readdir($handle))
        {
            if (is_dir($entry) && $entry != ".")
            {
                // Determine if the folder should be hidden
                if ($entry == "..")
                {
                    // Make sure that the back link isn't hidden
                    $subdirs_array[] = $entry;
                }
                else if ($hide_dot == FALSE || ($hide_dot == TRUE && ereg("^\.", $entry) == FALSE))
                {
                    $subdirs_array[] = $entry;
                }
            }
            else if ($entry != ".." && $entry != ".")
            {
                // Delete any lock files if needed
                if (ereg("\.fileman$", $entry) == TRUE && $edit_lock == TRUE)
                {
                    // Check to see if the lock file has been in place for more than 5 minutes
                    $time   = time() - (int) $timeout;
                    $left   = filemtime($entry) - $time;

                    // If the amount of time left is less than or equal to 0 unlock the file
                    if ($left <= 0)
                    {
                        unlink($entry);
                    }
                }
                else if ($hide_dot == FALSE || ($hide_dot == TRUE && ereg("^\.", $entry) == FALSE))
                {
                    // Determine if the file should be shown, i.e. not .something or file.fileman
                    $files_array[] = $entry;
                }
            }
        }

        // Sort the files and directories
        natcasesort($files_array);
        natcasesort($subdirs_array);

        // Sort the sub directories
        foreach($subdirs_array as $entry)
        {
            if ($entry == "..")
            {
                if ($dir != $params["root"])
                {
                    // need to check paths like /test/testing/test/
                    $base = basename($dir);
                
                    $prev = ereg_replace("[\\]*$", "", $dir);
                    $prev = ereg_replace("[/]*$", "", $prev);
                    $prev = ereg_replace($base . "$", "", $prev);
                    $prev = eregi_replace($safe, "", $prev);
                    $prev = ereg_replace("[/]*$", "", $prev);
                    $prev = ereg_replace("[\\]*$", "", $prev);

                    $up = "<a href=\"$PHP_SELF?dir=$prev\">..</a>";
                }
            }
            else
            {
                // Get the UNIX only information
                $unix   = unix($entry);
                
                $icon = "folder.gif";

                // If the folder is locked then show a locked icon
                if ($params["htpasswd"] == 1 && eregi("apache", param("SERVER_SOFTWARE", "SERVER")) && file_exists($entry . "/.htaccess") == TRUE && file_exists($entry . "/.htpasswd") == TRUE)
                {
                    $icon = "lockedfolder.gif";
                }

                // Build the array to parse the template
                $subdirs[$entry] = array(
                    "icon"      => "<img src=\"images/icons/$icon\" alt=\"$entry\" title=\"$entry\" />",
                    "name"      => "<a href=\"$PHP_SELF?dir=" . encode_relative($entry) . "\">$entry</a> (<a href=\"" . $params["root_url"] . "/" . encode_relative($entry) . "/\" target=\"_blank\">" . $main["view_dir"] . "</a>)",
                    "actions"   => action_buttons($entry, 1),
                    "chmod_val" => $unix["chmod"],
                    "owner"     => $unix["owner"],
                    "group"     => $unix["group"],
                    "mdate"     => date($format, filemtime($entry)),
                    "foldown"   => $main["foldown"],
                    "foldgroup" => $main["foldgroup"],
                    "chmod"     => $main["CHMOD"],
                    "zipfile"   => "<form action=\"#\"><input onclick=\"compress(this, 1);\" type=\"checkbox\" name=\"zipfolder\" value=\"$entry\" title=\"" . $main["checkfolder"] . "\" /></form>"
                );
            }
        }

        // Sort the file
        foreach($files_array as $entry)
        {
            // Get the file information
            $unix   = unix($entry);
            $ext    = ext($entry);

            // Get the file size and increase the counter
            $fsize = filesize($entry);
            $total = $total + $fsize;

            // Get the path to the source file
            $sourcefile = encode_relative($entry);
            $sourcefile = str_replace("\\", "/", $sourcefile);
			
            $icon = get_icon($entry);

            if (file_exists($entry . ".fileman") == TRUE && $edit_lock == 1)
            {
                $icon = "<img src=\"images/icons/lockedfile.gif\" alt=\"$file\" title=\"$file\" />";
            }

            $files[$entry] = array(
                "icon"      => $icon,
                "name"      => in_array($ext, $ascii) ? "<a href=\"" . $params["root_url"] . "/" . encode_relative($entry) . "\" target=\"_blank\">$entry</a> (<a href=\"javascript:open_window('" . $scripts["source"] . "?f=" . js_safe($sourcefile) . "');\" onmouseover=\"javascript:window.status='" . $main["source"] ."'; return true;\" onmouseout=\"javascript:window.status=''; return true;\">" . $main["source"] . "</a>)" : "<a href=\"" . $params["root_url"] . "/" . encode_relative($entry) . "\" target=\"_blank\">$entry</a>",
                "actions"   => action_buttons($entry),
                "fsize"     => size($fsize),
                "mdate"     => date($format, filemtime($entry)),
                "chmod_val" => $unix["chmod"],
                "owner"     => $unix["owner"],
                "group"     => $unix["group"],
                "fileown"   => $main["fileown"],
                "filegroup" => $main["filegroup"],
                "chmod"     => $main["CHMOD"],
                "size"      => $main["size"],
                "zipfile"   => "<form action=\"#\"><input onclick=\"compress(this, 0);\" type=\"checkbox\" name=\"zipfile\" value=\"$entry\" title=\"" . $main["checkfile"] . "\" /></form>"
            );
        }

        // Close the active directory
        closedir($handle);

        $total   = $total == "" ? "" : size($total);
        $columns = $total == "" ? 0 : 1;

        // Create the easy navigate link
        $safe_dir = eregi_replace($safe, $slash, $this_dir);
        $exploded = explode($slash, $safe_dir);

        // We need to fool the script into thinking this is the root directory
        $this_dir = $params["root_dir"];

        $final = $slash;
        $new = "";
        foreach ($exploded as $var)
        {
            if ($var != "")
            {
                $new .= $var; // Add the new directory

                $final .= "<a href=\"$PHP_SELF?dir=" . encode_relative($new) . "\" class=\"nav\">" . $var . "</a>" . $slash;

                $new .= $slash; // Add the trailing slash
            }
        }

        // Reset the directory to the real current directory
        $this_dir = $safe_dir;

        $info = array(
            "folders"       => $subdirs,
            "files"         => $files,
            "current"       => $dir,
            "total_size"    => $total,
            "columns"       => $columns,
            "msg"           => "",
            "up"            => $up,
            "this_dir"      => $this_dir,
            "nav"           => $final,
            "notes"         => $notes
        );
    }

    return $info;
}

// A function to parse the template files
function template($data, $file)
{
    global $starttime, $misc, $gzip, $javascript, $PHP_SELF, $charset, $script_url;

    if (is_array($data) == false)
    {
        return false;
    }

    $fp         = fopen($file, "r");
    $template   = fread($fp, filesize($file));
    fclose($fp);

    foreach ($data as $key => $var)
    { 
		$template = preg_replace("/{" . $key . "}/i", $var, $template);
	}

    // The template is the global template so it is safe to assume that this is the final parse
    if (basename($file) == "global.tpl")
    {
        $gzip       = preg_replace("/%g/i", $gzip, $misc["gzip"]);
        $template   = preg_replace("/{GZIP}/i", $gzip, $template);

        $template   = preg_replace("/{CHARSET}/i", $charset, $template);

        $stats      = endtime($starttime);
        $stats      = preg_replace("/%s/i", $stats, $misc["stats"]);
        $template   = preg_replace("/{STATS}/i", $stats, $template);

        echo $template;
        return;
    }

    return $template;
}

// A function to handle the dynamic templates
function get_blocks($blocks = array(), $file)
{
    if(($fp = fopen($file, "r")) == FALSE)
    {
        $file = basename($file);
        die(include_error($file . " template file"));
    }
    else
    {
        $template = fread($fp, filesize($file));
        fclose($fp);

        foreach ($blocks as $var)
        {
            preg_match("/<!-- BEGIN DYNAMIC BLOCK: " . $var . " -->(.+?)<!-- END DYNAMIC BLOCK: " . $var . " -->/si", $template, $regs);
            $dynamic[$var] = $regs[1];
            unset($regs);
        }

        return $dynamic;
    }
}

// A function to parse the dynamic data
function parse_dynamic($data, $template)
{
    foreach ($data as $key => $var)
    {
        $template = preg_replace("/{" . $key . "}/i", $var, $template);
    }

    return $template;
}

// A function to parse the blocks
function parse_block($name)
{
    global $blocks, $info;

    $temp = "" ; // Store the dynamic data block in a temp variable
    if (is_array($info[$name]))
    {
        foreach ($info[$name] as $var)
        {
            $temp .= parse_dynamic($var, $blocks[$name]);
        }
    }
    else if ($info[$name] != "")
    {
        $temp .= preg_replace("/{" . $name . "}/i", $info[$name], $blocks[$name]);
    }

    return $temp;
}

// A function to finalise the dynamic templates
function dyn_template($data, $file)
{
    if(($fp = fopen($file, "r")) == FALSE)
    {
        $file = basename($file);
        die(include_error($file . " template file"));
    }
    else
    {
        $template = fread($fp, filesize($file));
        fclose($fp);

        foreach ($data as $key => $var)
        {
            $template = preg_replace("/<!-- BEGIN DYNAMIC BLOCK: " . $key . " -->(.+?)<!-- END DYNAMIC BLOCK: " . $key . " -->/si", $var, $template);
        }

        return $template;
    }
}

// Returns the CHMOD value in octal
function chmod_value($file)
{
    $mode = fileperms($file);
    $mode &= 0x1ff; # Remove the bits we don't need

    $chmod = sprintf("%o", $mode);

    return $chmod;
}

// Gets the file extension
function ext($file)
{
    $temparray = explode(".", $file);
    $extension = $temparray[count($temparray) - 1];
    $extension = strtolower($extension);
 
	// There is no extension
	if (isset($temparray[1]) == FALSE)
	{
		return "";
	}

    return $extension;
}

// Gets the icon for the file
function get_icon($file)
{
    global $icons;
    reset($icons);

    $extension = ext($file);
    if ($extension == "")
    {
        return "<img src=\"images/icons/unknown.gif\" alt=\"$file\" title=\"$file\" />";
    }

    while(list($key, $value) = each($icons))
    {
        $iconlist = explode(" ", $value);
        foreach($iconlist as $icon)
        {
            if ($icon == $extension)
            {
                return "<img src=\"images/icons/$key\" alt=\"$file\" TITLE=\"$file\" />";
            }
        }
    }

    return "<img src=\"images/icons/unknown.gif\" alt=\"$file\" TITLE=\"$file\" />";
}

// Formats the file size into a readable value
function size($filesize)
{
    global $main;

    if ($filesize >= 1073741824)
    {
        $filesize = round($filesize / 1073741824 * 100) / 100 . " " . $main["gigabyte"];
    }
    else if ($filesize >= 1048576)
    {
        $filesize = round($filesize / 1048576 * 100) / 100 . " " . $main["megabyte"];
    }
    else if ($filesize >= 1024)
    {
        $filesize = round($filesize / 1024 * 100) / 100 . " " . $main["kilobyte"];
    }
    else
    {
        $filesize = $filesize . " " . $main["byte"];
    }

    return $filesize;
}

// A function to return the UNIX only information
function unix($file)
{
    global $main;

    if (function_exists("posix_getpwuid") && function_exists("posix_getgrgid"))
    {
        // Check that the user is running on a UNIX system
        $owner = posix_getpwuid(fileowner($file));
        $group = posix_getgrgid(filegroup($file));

        $unix["owner"] = $owner["name"];
        $unix["group"] = $group["name"];
    }
    else
    {
        $unix["owner"] = $main["na"];
        $unix["group"] = $main["na"];
    }

    if (eregi("win", PHP_OS))
    {
        $unix["chmod"] = $main["na"];
    }
    else
    {
        $unix["chmod"] = chmod_value($file);
    }

    return $unix;
}

// A function to build the templates drop down list
function dropdown($items, $selected = 0)
{
    $list = "";

    foreach ($items as $key => $var)
    {
        if ($key == $selected)
        {
            $list .= "<option value=\"$key\" selected=\"selected\">" . $var . "</option>";
        }
        else
        {
            $list .= "<option value=\"$key\">" . $var . "</option>";
        }
    }

    return $list;
}

// A function to generate the area buttons
function area_buttons()
{
    global $area, $scripts, $params, $anon_access;

    $areas = "";
    $areas .= $params["mysql"] == 1 ? "<a href=\"" . $scripts["sql"] . "\" onmouseover=\"javascript:window.status='" . $area["sql"] . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/sql.gif\" alt=\"" . $area["sql"] . "\" title=\"" . $area["sql"] . "\" border=\"0\" /></a> " : "";    // Can the user access MySQL?
    $areas .= "<a href=\"" . $scripts["space"] . "\" onmouseover=\"javascript:window.status='" . $area["space"] . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/space.gif\" alt=\"" . $area["space"] . "\" title=\"" . $area["space"] . "\" border=\"0\" /></a> <a href=\"" . $scripts["main"] . "\" onmouseover=\"javascript:window.status='" . $area["home"] . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/home.gif\" alt=\"" . $area["home"] . "\" title=\"" . $area["home"] . "\" border=\"0\" /></a> ";
    $areas .= $params["change"] == 1 ? "<a href=\"" . $scripts["pass"] . "\" onmouseover=\"javascript:window.status='" . $area["pass"] . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/password.gif\" alt=\"" . $area["pass"] . "\" title=\"" . $area["pass"] . "\" border=\"0\" /></a> " : "";    // Can the user change their password?
    $areas .= $anon_access == 1 ? "" : "<a href=\"" . $scripts["login"] . "?op=out\" onmouseover=\"javascript:window.status='" . $area["login"] . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/logout.gif\" alt=\"" . $area["out"] . "\" title=\"" . $area["out"] . "\" border=\"0\" /></a>";

    return $areas;
}

// Cleans the path so it is "safe"
function cleanpath($path, $dots = 1)
{
    if ($dots == 1)
    {
        $path = ereg_replace("\.[\.]+", "", $path);     // Remove dots ...
    }

    $path = ereg_replace("^[\/]+", "", $path);      // Remove leading slashes
    $path = ereg_replace("[\/]+$", "", $path);      // Remove trialing slashes
    $path = ereg_replace("\\{2,}", "\\", $path);    // Replace groups of \\ with \
    $path = ereg_replace("/{2,}", "/", $path);      // Replace groups of // with /

    return $path;
}

// A function to make variables javascript safe
function js_safe($var, $link = 1)
{
    if ($link == 1)
    {
        $var = str_replace("#", "%23", $var);
    }

	$var = str_replace("'", "\'", $var);
	return str_replace("%27", "\%27", $var);
}

// A function to create the "actions" list
function action_buttons($file, $is_folder = 0)
{
    global $scripts, $params, $tools, $this_dir, $ascii, $javascript, $slash, $no_ext;

    $actions    = "";
    $dir        = encode_relative("");

    // We don't need to show the CHMOD option on Windows
    if (eregi("win", PHP_OS) == FALSE)
    {
        $dir = str_replace("\\", "/", $dir);
        $actions .= $params["CHMOD"] == 1 ? "<a href=\"javascript:open_window('" . $scripts["chmod"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir) . "');\" onmouseover=\"javascript:window.status='" . $tools["chmod"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/chmod.gif\" alt=\"" . $tools["chmod"] . " $file\" title=\"" . $tools["chmod"] . " $file\" border=\"0\" /></a>" : "";
    }

    $actions .= $params["rename"] == 1 ? "<a href=\"Javascript:rename('" . js_safe($file) . "', '" . js_safe($dir) . "');\" onmouseover=\"javascript:window.status='" . $tools["rename"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/rename.gif\" alt=\"" . $tools["rename"] . " $file\" title=\"" . $tools["rename"] . " $file\" border=\"0\" /></a>" : "";

    if ($is_folder == 1)
    {
        $actions .= $params["delete"] == 1 ? "<a href=\"Javascript:delDir('" . js_safe($file) . "', '" . js_safe($dir) . "');\" onmouseover=\"javascript:window.status='" . $tools["unlink"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/delete.gif\" alt=\"" . $tools["unlink"] . " $file\" title=\"" . $tools["unlink"] . " $file\" border=\"0\" /></a>" : "";
        $actions .= $params["copy"] == 1 ? "<a href=\"Javascript:open_window('" . $scripts["move"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir). "&amp;act=3');\" onmouseover=\"javascript:window.status='" . $tools["copy"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/copy_d.gif\" alt=\"" . $tools["copy"] . " $file\" title=\"" . $tools["copy"] . " $file\" border=\"0\" /></a>" : "";
        $actions .= $params["move"] == 1 ? "<a href=\"Javascript:open_window('" . $scripts["move"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir) . "&amp;act=1');\" onmouseover=\"javascript:window.status='" . $tools["move"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/move_d.gif\" alt=\"" . $tools["move"] . " $file\" title=\"" . $tools["move"] . " $file\" border=\"0\" /></a>" : "";
    }
    else
    {
        $actions .= $params["delete"] == 1 ? "<a href=\"Javascript:delFile('" . js_safe($file) . "', '" . js_safe($dir) . "');\" onmouseover=\"javascript:window.status='" . $tools["unlink"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/delete.gif\" alt=\"" . $tools["unlink"] . " $file\" title=\"" . $tools["unlink"] . " $file\" border=\"0\" /></a>" : "";
        $actions .= $params["copy"] == 1 ? "<a href=\"Javascript:open_window('" . $scripts["move"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir) . "&amp;act=4');\" onmouseover=\"javascript:window.status='" . $tools["copy"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/copy_f.gif\" alt=\"" . $tools["copy"] . " $file\" title=\"" . $tools["copy"] . " $file\" border=\"0\" /></a>" : "";
        $actions .= $params["move"] == 1 ? "<a href=\"Javascript:open_window('" . $scripts["move"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir) . "&amp;act=2');\" onmouseover=\"javascript:window.status='" . $tools["move"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/move_f.gif\" alt=\"" . $tools["move"] . " $file\" title=\"" . $tools["move"] . " $file\" border=\"0\" /></a>" : "";
    }

    if ($is_folder == 1 && eregi("apache", param("SERVER_SOFTWARE", "SERVER")))
    {

        $actions .= $params["htpasswd"] == 1 ? "<a href=\"Javascript:open_window('" . $scripts["lock"] . "?f=" . js_safe($file) . "&amp;d=" . js_safe($dir) . "');\" onmouseover=\"javascript:window.status='" . $tools["htpasswd"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/htpasswd.gif\" alt=\"" . $tools["htpasswd"] . " $file\" title=\"" . $tools["htpasswd"] . " $file\" border=\"0\" /></a>" : "";
    }

    if ($params["edit"] == 1 && is_file($file) && (in_array(ext($file), $ascii) || ($no_ext == 1 && ext($file) == "")))
    {
        $actions .= "<a href=\"" . $scripts["edit"] . "?op=edit&amp;f=" . js_safe($file) . "&amp;dir=" . js_safe($dir) . "\" onmouseover=\"javascript:window.status='" . $tools["edit"] . " " . js_safe($file, 0) . "'; return true;\" onmouseout=\"javascript:window.status=''; return true;\"><img src=\"images/edit.gif\" alt=\"" . $tools["edit"] . " $file\" title=\"" . $tools["edit"] . " $file\" border=\"0\" /></a>";
    }

    return $actions;
}

// A path to work out the relative path and encode it
function encode_relative($entry)
{
    global $this_dir, $params, $slash, $safe;

    // Get the relative path from the root
    $path       = $this_dir . $entry;

    // Although we are replacing a simple string, we have to use ereg because str_replace don't work
    $path       = eregi_replace($safe, "", $path);

    // Encode the file name
    $file       = basename($path);
    $encoded    = rawurlencode($file);
    $encoded    = str_replace("%00", "%2F", $encoded); // Fix a small safe mode bug
    $path       = str_replace($file, $encoded, $path);

    // We need to swap slashes to make them Windows Safe
    $path       = str_replace("\\", "/", $path);

    $path       = cleanpath($path, 0);

    return $path;
}

// Return the directory size
function dirsize($dir)
{
    global $slash;

    $dp     = opendir($dir);
    $size   = 0;

    while (($file = readdir($dp)) != false)
    {
        if ($file != "." && $file != "..")
        {
            $path = $dir . $slash . $file;

            if (is_dir($path))
            {
                $size = $size + dirsize($path);
            }
            else if (is_file($path))
            {
                $size = $size + filesize($path);
            }
        }
    }

    closedir($dp);

    return $size;
}

// A function to remove an entire directory
function remove_dir($dir)
{
    global $slash;

    // Create arrays to store files and directories
    $dir_files      = array();
    $dir_subdirs    = array();

    $dir = ereg_replace("[/]*$", "", $dir);
    $dir = ereg_replace("[\\]*$", "", $dir);

    // Make sure we can delete it
    chmod($dir, 0777);

    // Change to directory
    chdir($dir);

    if ((($handle = opendir($dir))) == FALSE)
    {
        // The directory could not be opened
        return false;
    }

    // Loop through all directory entries, and construct two temporary arrays containing files and sub directories
    while($entry = readdir($handle))
    {
        if (is_dir($entry) && $entry !=  ".." && $entry !=  ".")
        {
            $dir_subdirs[] = $entry;
        }
        else if ($entry !=  ".." && $entry !=  ".")
        {
            $dir_files[] = $entry;
        }
    }

    // Delete all files in the curent directory return false and halt if a file cannot be removed
    for($i=0; $i<count($dir_files); $i++)
    {
        chmod($dir_files[$i], 0777);

        if (((unlink($dir_files[$i]))) == FALSE)
        {
            return false;
        }
    }

    // Empty sub directories and then remove the directory
    for($i=0; $i<count($dir_subdirs); $i++)
    {
        chmod($dir . $slash . $dir_subdirs[$i], 0777);

        if (remove_dir($dir . $slash . $dir_subdirs[$i]) == FALSE)
        {
            return false;
        }
        else if (rmdir($dir . $slash . $dir_subdirs[$i]) == FALSE)
        {
            return false;
        }
    }

    // Close directory
    closedir($handle);

    // Success, every thing is gone return true
    return true;
}

// A function to remove slashes to be passed to array walk
function removeslash(&$item)
{
    return stripslashes($item);
}

// A function to return the correct variable
function param($name, $method, $safe = 0)
{
    global $debug;

    // Turn off error reporting as this function will return errors alot of the time
    error_reporting(0);

    // Handle file uploading
    if ($method == "FILES")
    {
        // The file upload arrays have a different structure
        return isset($_FILES) ? $_FILES[$name] : $GLOBALS["HTTP_POST_FILES"][$name];
    }

    // Use ternary, check if the method exists in the super global area, ie _METHOD
    // If so return the value from that array, otherwise use the GLOBALS array
    // along with the HTTP_METHOD_VARS index to return the correct value
    $var = isset($_{$method}) ? $_{$method}[$name] : $GLOBALS["HTTP_{$method}_VARS"][$name];

    // Stripslashes if needed
    if (get_magic_quotes_gpc() == TRUE)
    {
        if (is_array($var) == TRUE)
        {
            // Stripslashes from array items
            array_walk($var, "removeslashes");
        }
        else
        {
            // Stripslashes from the string
            $var = stripslashes($var);
        }
    }

    // Reset the error reporting level
    if ($debug == true)
    {
        error_reporting(E_ALL ^ E_NOTICE);
    }

    // Remove | as the data is going to be inserted into the user file
    if ($safe == 1)
    {
        $var = str_replace("|", "", $var);
    }

    if (is_array($var) == FALSE)
    {
        // Decode the string
        $var = rawurldecode($var);
    }
    return $var;
}

// A function to find out if GD with PNG support is installed
function gdinstalled()
{
    // Find out the module info
	$extension_dir = ini_get("extension_dir");
    if (eregi("win", PHP_OS))
    {
      	$lib = "php_gd.dll";
    }
	else
    {
		$lib = "php_gd.so";
	}

    // Check if the module is loaded, or try to load it
    if (extension_loaded("gd") == TRUE)
    {
        $loaded = 1;
	}
	else if (ini_get("enable_dl") == 0)
    {
		return false;
	}
	else if (ini_get("safe_mode") == 0)
    {
        return false;
	}
    else if (extension_loaded("gd") == FALSE)
    {
		ini_set("extension_dir", "./");

		if (file_exists("./" . $lib) && dl($lib))
        {
            $loaded = 1;
        }
        else
        {
            return false;
        }
	}

    // GD is loaded so check for PNG support
	if($loaded == 1)
    {
		if (ImageTypes() & IMG_PNG)
        {
            // PNG is supported
			return true;
		}
        else
        {
            // PNG is not supported
            return false;
        }
	}
    else
    {
        return false;
    }
}

// A function to copy a directory
function copy_dir($source, $target)
{
    global $slash;

    // Define temp variables
    $copy_subdirs    = array();
    $copy_files      = array();

    $chmod = chmod_value($source);
    mkdir($target, 0777);

    // Open the source directory
    if (($handle = opendir($source)) == FALSE)
    {
        return false; // Directory couldn't be opened
    }

    while ($entry = readdir($handle))
    {
        if ($entry != "." && $entry != "..")
        {
		    if (is_dir($source . $entry) == TRUE)
            {
                $copy_subdirs[] = $entry;
            }
            else if (is_file($source . $entry) == TRUE)
            {
                $copy_files[] = $entry;
    		}
		}
	}

    // Run the copy_dir function for every directory in the array
    foreach($copy_subdirs as $entry)
    {
        if (copy_dir($source . $entry . $slash, $target . $entry . $slash) == FALSE)
        {
            return false;
        }
    }

    // Run the copy function for every file in the array
    foreach($copy_files as $entry)
    {
        if (copy($source . $entry, $target . $entry) == FALSE)
        {
            return false;
        }
    }

	closedir($handle); // Close the directory
    chmod($target, octdec($chmod)); // Reset the CHMOD

    return true;
}

// Output HTTP headers and redirect
function redirect($location, $login = 0)
{
    global $script_url;

    $server = param("SERVER_SOFTWARE", "SERVER");

    if (preg_match("/iis/i", $server) == TRUE)
    {
        // A temporary fix until I discover why IIS isn't saving cookies when the location header is sent
        exit("<html><head><meta http-equiv=\"refresh\" content=\"0; url=" . $script_url . "/" . $location . "\"></head><body></body></html>");
    }
    else
    {
        header("Location: " . $script_url . "/" . $location . "\r\n"); // Send the location header
        exit(); // Stop any more output
    }
}

// Cleans CRLF data to match the platform
function clean_crlf($data)
{
    $server = param("SERVER_SOFTWARE", "SERVER");
    
    // If windows isn't being used, or apache is being used, remove the \r
    if (eregi("win", PHP_OS) == FALSE || eregi("apache", $server) == TRUE)
    {
        $data = str_replace("\r\n", "\n", $data);
    }

    return $data;
}

?>