<?php

/*
 * Invision Power File Manager
 * Header Library
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 * Last Modified: 23rd February 2003 
 *
 */

// A function to handle include errors
function include_error($msg)
{
    echo "<html>\r\n";
    echo "<head>\r\n";
    echo "<title>Error!</title>\r\n";
    echo "</head>\r\n";
    echo "<body bgcolor=\"#FFFFFF\">\r\n";
    echo "<center>\r\n";
    echo "<font face=\"verdana\" color=\"#000000\" size=\"1\"><b>" . $msg . "</b></font>\r\n";
    echo "</center>\r\n";
    echo "</body>\r\n";
    echo "</html>";
    exit();
}

set_magic_quotes_runtime(0);

if (!(include("./settings/settings.inc.php")))
{
    include_error("There was an error loading the global settings file");
}

if (file_exists($script_dir) == FALSE)
{
    if (eregi("win", PHP_OS) == TRUE)
    {
        include_error("The script directory setting is invalid");
    }
    else
    {
        include_error("The script directory setting is invalid.<br />Remember that on Unix based platforms directory names are case sensitive");
    }
}

if (!(include($script_dir . "/settings/languages.inc.php")))
{
    include_error("There was an error loading the language settings file");
}
if (!(include($script_dir . "/settings/templates.inc.php")))
{
    include_error("There was an error loading the templates settings file");
}
if (!(include($script_dir . "/modules/common.lib.php")))
{
    include_error("There was an error loading the common code module");
}
if (!(include($script_dir . "/languages/" . $lang_file[$default_lang] . ".lng.php")))
{
    include_error("There was an error loading the " . $lang_name[$default_lang] . " language pack");
}

// Enable HTTP headers if allowed
if ($http_headers == 1)
{
	header("Content-type: text/html\r\n");                              // Output a content type header
	header("Expires: Mon, 26 Jul 1997 05:00:00 GMT\r\n");               // Date in the past
	header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT\r\n");  // Always modified
	header("Cache-Control: no-store, no-cache, must-revalidate\r\n");   // HTTP/1.1
	header("Cache-Control: post-check=0, pre-check=0\r\n", FALSE);
	header("Pragma: no-cache\r\n");                                     // HTTP/1.0
}

// Enable GZIP output compression if possible
$gzip = 0;
if (ini_get("zlib.output_compression") == TRUE)
{
    $gzip = 1;
}
else if (phpversion() >= "4.0.4pl1" && extension_loaded("zlib") && $use_gzip == 1)
{
    ob_end_clean();
    ob_start("ob_gzhandler");
    $gzip = 1;
}

if ($debug == TRUE)
{
    error_reporting(E_ALL);
}

$starttime  = starttime();
$PHP_SELF   = param("PHP_SELF", "SERVER");
$slash      = eregi("win", PHP_OS) ? "\\" : "/"; // Find out the correct trailing slash for the OS
$lang       = 0;
$msg        = "";

// If the user is on the login screen see if they are trying to use a language pack
if (basename($PHP_SELF) == $scripts["login"])
{
    $lang = param("lang", "GET");

    if (empty($lang))
    {
        $lang = param("language", "POST");
    }

    // Load the language pack
    if ($lang != 0 && isset($lang_name[$lang]))
    {
        if (!(include($script_dir . "/languages/" . $lang_file[$lang] . ".lng.php")))
        {
            include_error($lang_name[$lang] . " language pack");
        }
    }

    // User does not need to log in
    if ($anon_access == TRUE)
    {
        redirect($scripts["main"]);
    }
}
else
{
    // Check if anonymous access is enabled
    if ($anon_access == FALSE)
    {
        // Check that the user is authorised
        if (($params = auth_user(param($cookie_user, "COOKIE"), param($cookie_pass, "COOKIE"))) == FALSE)
        {
            redirect($scripts["login"] . "?op=out");
        }
    }
    else
    {
        // Get the anonymous access details
        $params = auth_user("guest", md5(""));
    }

    $lang_cookie = param($cookie_lang, "COOKIE");
    // Check if the user has set a cookie for language
    if ((int) $lang_cookie != 0 && isset($lang_name[(int) $lang_cookie]))
    {
        if (!(include($script_dir . "/languages/" . $lang_file[(int) $lang_cookie] . ".lng.php")))
        {
            include_error($lang_name[(int) $lang_cookie] . " language pack");
        }
    }
    else if ($params["lang"] != 0 && isset($lang_name[(int) $params["lang"]]))
    {
        // Load their default language pack
        if (!(include($script_dir . "/languages/" . $lang_file[(int) $params["lang"]] . ".lng.php")))
        {
            include_error($lang_name[(int) $params["lang"]] . " language pack");
        }
    }
}

$params["root"] = $params["root"] . $slash;

// Make the path regex safe
$safe = eregi("win", PHP_OS) == TRUE ? addslashes($params["root"]) : $params["root"];

// Set the GZIP marker
$gzip = $gzip == 1 ? $misc["enabled"] : $misc["disabled"];

?>