<?php

/*
 * Invision Power File Manager v1
 * Global Configuration Script
 * Copyright (c) 2003 Invision Power Services
 * -------------------------------------
 * You may not remove the copyright or
 * redistribute the script in any form
 *
 * Authors: Stephen Ball <stephen@invisionfilemanager.com>
 *
 */

// Misc Settings
$script_dir      = ""; // The directory the script is in
$script_url      = ""; // The URL to the script
$cookie_admin    = "fm_admin"; // The name of the admin cookie
$cookie_user     = "fm_username"; // The name for the username cookie
$cookie_pass     = "fm_password"; // The name for the password cookie
$cookie_lang     = "fm_language"; // The name for the language cookie
$cookie_temp     = "htpass"; // The name for the temporary htpasswd cookie
$cookie_time     = NULL; // The length of time to store the cookies (leave blank for deletion upon browser closure)
$default_lang    = 1; // The default language to use
$debug           = FALSE; // Enable Debug mode (to report errors)
$format          = "M j, Y {\A\\T} g:i a"; // The format to use for the file dates
$hide            = ".hide"; // The name of the file used to prevent directory access
$note            = ".note"; // The name of the file used for directory notes
$hide_dot        = TRUE; // Hide files beginning with a . dot
$flock           = TRUE; // Flock files
$upload_limit    = 5; // Number of file browsers to show on multi file upload page
$no_ext			 = TRUE; // Display edit for files with no extension
$edit_lock		 = FALSE; // Lock files which are being edited
$timeout         = NULL; // Number of seconds to keep files locked for
$use_gzip		 = TRUE; // USE GZIP compression
$http_headers	 = TRUE; // Output HTTP headers
$anon_access     = FALSE; // Anonymous access
$new_chmod       = "755"; // CHMOD value for new files
$adminpass       = ""; // The admin password

// The file extensions and images to use for the icons
$icons = array(
    "image.gif" => "bmp gif jpeg jpg png",
    "text.gif" => "dat ini lib log tpl txt note pls m3u",
    "script.gif" => "bat cgi js php php3 php4 phps phtml pl sh pm",
    "zip.gif" => "ace gz rar tar zip",
    "html.gif" => "css dtd htm html shtm shtml wml xml xsl",
    "sound.gif" => "au mid mod mp3 wav",
    "movie.gif" => "mov mpeg mpg rm",
    "pdf.gif" => "pdf",
    "database.gif" => "db mdb sql",
    "binary.gif" => "com dll exe sys"
);

// An array of extensions to ASCII files so that the script knows what can be edited
$ascii = array("asp", "bat", "cfm", "cgi", "conf", "css", "dat", "diz", "dtd", "htm", "html", "inc", "inf", "ini", "js", "lib", "log", "m3u", "mrc", "nfo", "note", "php", "php3", "php4", "phps", "phtml", "pl", "pls", "pm", "reg", "sh", "shtm", "shtml", "sql", "tpl", "txt", "wml", "xml", "xsl");

// An array of the script names (so that the scripts can be renamed)
$scripts["login"]    = "login.php";
$scripts["main"]     = "index.php";
$scripts["edit"]     = "edit.php";
$scripts["source"]   = "source.php";
$scripts["space"]    = "space.php";
$scripts["pass"]     = "pwd.php";
$scripts["sql"]      = "sql.php";
$scripts["chmod"]    = "chmod.php";
$scripts["move"]     = "move.php";
$scripts["lock"]     = "lock.php";
$scripts["upload"]   = "upload.php";
$scripts["userlist"] = "users.cgi";

// The scripts visual settings
$free_colour    = array("70", "130", "180"); // The colours to use for the free space on the pie chart
$used_colour    = array("255", "255", "255"); // The colours to use for the used space on the pie chart

$license        = 0; // The license status

?>